% Projekt:          spacecraft
% Auftraggeber:     Institut fr Systemtheorie und Regelungstechnik (IST)
% Autor:            Dipl.-Ing. (BA) Johannes Eck


function varargout = spacecraft(varargin)
% SPACECRAFT M-file for spacecraft.fig
%      SPACECRAFT, by itself, creates a new SPACECRAFT or raises the
%      existing
%      singleton*.
%
%      H = SPACECRAFT returns the handle to a new SPACECRAFT or the handle
%      to
%      the existing singleton*.
%
%      SPACECRAFT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SPACECRAFT.M with the given input
%      arguments.
%
%      SPACECRAFT('Property','Value',...) creates a new SPACECRAFT or raises
%      the
%      existing singleton*.  Starting from the left, property value pairs
%      are
%      applied to the GUI before spaceball_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property
%      application
%      stop.  All inputs are passed to spacecraft_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help spacecraft

% Last Modified by GUIDE v2.5 26-May-2009 21:45:45

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @spacecraft_OpeningFcn, ...
                   'gui_OutputFcn',  @spacecraft_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT






%**************************************************************************
%**************************************************************************


function spacecraft_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;                                                   % Choose default command line output for spaceball
guidata(hObject, handles);                                                  % Update handles structure
global delta_t kurve_x kurve_y_start pause_status; 
global sonnenwindpos sonnenwindneg sonnenwind;
global landebahn_schwarz landebahn_gruen;
global lektion m;
global K_z1 K_z2;
global ball1 ball2;
clc;                                                                        % Lsche Kommandofenster
set(0,'ShowHiddenHandles','on');                                            % ermglicht Zugriff auf versteckte Handles
lade_shuttle_bilder(handles);                                               % lade die Bilder der Shuttles in Struktur
m = 10;                                                                     % Masse m = 10 kg
K_z1 = tf(0);                                                               % setze Strbertragungsfkt1 auf 0
K_z2 = tf(0);                                                               % setze Strbertragungsfkt2 auf 0
lektion = 0;                                                                % aktiviere Lektion 0
sonnenwind = 0;                                                             % Sonnenwind rcksetzen
pause_status = false;                                                       % Status Pause deaktiviert
delta_t = 0;                                                                % Zeitfortschritt des Spiels = 0
kurve_x = -2:0.1:40;                                                        % x-Werte fr Sollkurve
kurve_y_start = sin(kurve_x);                                               % Default-Verlauf der Sollkurve

[spaceball2_bild dummy spaceball2_trans]...                                 % lese Spaceball-Bild ein
    = imread('spaceball2.png');
axes(handles.spaceball2);                                                   % lege aktuelles Plotfenster fest
spaceball2_plot = image(spaceball2_bild);                                   % zeige gespeichertes Bild an
set(handles.spaceball2, 'Visible', 'off');                                  % blende Achsenbeschriftung aus
set(spaceball2_plot,'AlphaData',spaceball2_trans);                          % mache das Bild transparent
pos = get(handles.spaceball2, 'Position');                                  % lese aktuelle Position Spaceball2 ein
ball2 = struct('x0',0.1854,'y0',pos(2),'width',pos(3),'height',pos(4));     % speichere die Position in Struktur ball2

[spaceball1_bild dummy spaceball1_trans]...                                 % lese Spaceball-Bild ein
    = imread('spaceball1.png');
axes(handles.spaceball1);                                                   % lege aktuelles Plotfenster fest
spaceball1_plot = image(spaceball1_bild);                                   % zeige gespeichertes Bild an
set(handles.spaceball1, 'Visible', 'off');                                  % blende Achsenbeschriftung aus
set(spaceball1_plot,'AlphaData',spaceball1_trans);                          % mache das Bild transparent
pos = get(handles.spaceball1, 'Position');                                  % lese aktuelle Position Spaceball1 ein
ball1 = struct('x0',0.1854,'y0',pos(2),'width',pos(3),'height',pos(4));     % speichere die Position in Struktur ball2

startbildschirm_zeichnen(lektion, handles);                                 % zeichne Startbildschirm fr Lektion 0
sonnenwindpos = imread('sonnenwindpositiv.bmp');                            % lade Sonnenwindbilder
sonnenwindneg = imread('sonnenwindnegativ.bmp');
landebahn_schwarz = imread('landebahn_schwarz.bmp');                        % lade Bilder fr Landebahn
landebahn_gruen = imread('landebahn_gruen.bmp');

shuttle_ohne_lastw = imread('shuttle_ohne_lastwechsel.bmp');
axes(handles.axes_shuttle_ohne_lastw);
image(shuttle_ohne_lastw);
set(handles.axes_shuttle_ohne_lastw, 'Visible', 'off');

shuttle_mit_lastw = imread('shuttle_mit_lastwechsel.bmp');
axes(handles.axes_shuttle_mit_lastw);
image(shuttle_mit_lastw);
set(handles.axes_shuttle_mit_lastw, 'Visible', 'off');
set(handles.axes_shuttle_mit_lastw, 'Position',...
    [2.0258 0.3667 0.5822 0.481]);

set(handles.axes_eta, 'Visible','off', 'XLim',[-1 0], 'YLim',[-1 1]);

ist = imread('ist.bmp');                                                    % lade ist-Logo
axes(handles.axes10);                                                       % setze axes-Handle auf axes10
image(ist);                                                                 % zeige ist-Logo
set(handles.axes10, 'Visible', 'off');                                      % blende Achsenbeschriftung aus

set(handles.kurvenmenu, 'Value', 1);                                        % setze Kurvenmen auf Sinus                              
set(handles.schwierigkeitsmenu, 'Value', 1);                                % setze Schwierigkeitsmen auf Anfnger
set(handles.lektionsmenu, 'Value', 1);                                      % setze Lektionsmen auf Lektion1

assignin('base', 'lektion1_auswahl', 0);                                    % speichere im Workspace, dass Lektion1 nicht ausgewhlt wurde
assignin('base', 'lektion1_K_z1', 0);                                       % speichere default-bertragungsfkt der Strentkopplung Spieler1
assignin('base', 'lektion1_K_z2', 0);                                       % speichere default-bertragungsfkt der Strentkopplung Spieler2

assignin('base', 'lektion2_auswahl', 0);                                    % speichere im Workspace, dass Lektion2 nicht ausgewhlt wurde
assignin('base', 'lektion2_K_r_innen', 0);                                  % speichere default-Reglerparameter der Kaskadenregelung im WS
assignin('base', 'lektion2_T_v_innen', 0);
assignin('base', 'lektion2_K_r_aussen', 0);

assignin('base', 'lektion3_auswahl', 0);                                    % speichere im Workspace, dass Lektion3 nicht ausgewhlt wurde

truesize_test = which('truesize');                                          % prfe, ob truesize.m vorhanden ist
if strcmp(truesize_test,'')                                                 % falls truesize.m nicht vorhanden...
    fprintf(['******************************************************\n',... % Gebe Fehlermeldung im Command-Window aus
            '*                                                    *\n',...
            '* SpacecraftRT Fehlermeldung:                        *\n',...
            '* Die Image-Processing-Toolbox wurde nicht gefunden! *\n',...
            '*                                                    *\n',...            
            '******************************************************\n']);
end;

truesize(Lektion0);                                                         % ffne Lektion0 in Originalgre
uiwait(Lektion0);                                                           % warte auf Rckmeldung
close(Lektion0);                                                            % schliee Lektion0




function Startbutton_Callback(hObject, eventdata, handles)
global kurve_y kurve_y_start ttimer delta_t;
global z w_alt1 w_alt2;
global x_speicher y_speicher sp1_yspeicher sp2_yspeicher z_speicher;
global gamma_speicher nickwinkel_speicher sp1_fehler sp2_fehler;
global eta_speicher
global h_p_speicher;
global lektion;

set(handles.Startbutton, 'Enable', 'off');                                  % deaktiviere Startbutton
set(handles.Pausebutton, 'Enable', 'on');                                   % aktiviere Pausebutton
set(handles.Stopbutton, 'Enable', 'on');                                    % aktiviere Stopbutton

set(handles.slider, 'Value', 0);                                            % Positionierung des Sliders
delta_t = 0;                                                                % Zeitfortschritt des Spiels = 0                                                        
kurve_y = kurve_y_start;                                                    % bernehme Startkurve
w_alt1 = 0;                                                                 % Startfhrungsgre von Spieler1 = 0
w_alt2 = 0;                                                                 % Startfhrungsgre von Spieler2 = 0
x_speicher = [0];                                                           % Setze Speicher der x-Werte = 0
sp1_yspeicher = [0];                                                        % Setze Speicher des Ausgangs Spieler1 = 0
sp2_yspeicher = [0];                                                        % Setze Speicher des Ausgangs Spieler2 = 0
y_speicher = [0];                                                           % Setze Speicher der Sollkurve = 0
z_speicher = [0];                                                           % Setze Speicher des Strgrenverlaufs = 0
sp1_fehler = 0;                                                             % Setze Fehler Spieler1 = 0
sp2_fehler = 0;                                                             % Setze Fehler Spieler2 = 0
gamma_speicher = [0];                                                       % Setze Speicher von gamma = 0
nickwinkel_speicher = [0];                                                  % Setze Speicher des Nickwinkels = 0
eta_speicher = [0];
h_p_speicher = [0];                                                         % Setze Speicher Steiggeschwindigkeit = 0

reglerparameter_einlesen(handles);                                          % lese Reglerparameter ein
switch lektion                                                              % Auswahl der Lektion
    case 0
        systemberechnung_lektion0(handles);                                 % Ausgangssystem
    case 1
        systemberechnung_lektion1(handles);                                 % Strgrenaufschaltung
    case 2  
        systemberechnung_lektion2(handles);                                 % Kaskadenregelung
    case 3
        systemberechnung_lektion3(handles);                                 % LQR
end;

z=[0 0]';                                                                   % Rcksetzten der Strgre
cla(handles.axes2);                                                         % lsche Sonnenwindanzeigen
cla(handles.axes3);

eingabefenster('off', handles);                                             % Eingabefenster deaktivieren

ttimer = timer('TimerFcn', {@timer_callback, handles}, 'Period', 0.1,...    % Deklaration des Timers
    'ExecutionMode', 'fixedRate');
start(ttimer);                                                              % Starten des Timers





function Pausebutton_Callback(hObject, eventdata, handles)
global ttimer pause_status;
if pause_status == false                                                    % Wenn Pause deaktiviert ist...
    stop(ttimer);                                                           % stoppe den Timer
    set(handles.Pausebutton, 'String', 'Weiter');                           % Neubeschriftung des Pausebuttons
    pause_status = true;                                                    % Pause-Status aktiviert
else                                                                        % ...ansonsten...
    start(ttimer);                                                          % starte Timer
    set(handles.Pausebutton, 'String', 'Pause');                            % Neubeschriftung des Pausebuttons
    pause_status = false;                                                   % Pause-Status deaktiviert
end;





function Stopbutton_Callback(hObject, eventdata, handles)
global ttimer delta_t lektion;
stop(ttimer);                                                               % stoppe Timer
delete(ttimer);                                                             % lsche Timer
set(handles.slider, 'Value', 0);                                            % Startposition des Sliders
set(handles.Startbutton, 'Enable', 'on');                                   % aktiviere Startbutton
set(handles.Pausebutton, 'Enable', 'off');                                  % deaktiviere Pausebutton
set(handles.Stopbutton, 'Enable', 'off');                                   % deaktiviere Stopbutton
eingabefenster('on', handles);                                              % Eingabefenster aktivieren
delta_t = 0;                                                                % sezte Zeitfortschritt auf 0
startbildschirm_zeichnen(lektion, handles);                                 % zeige Startbildschirm neu an




function timer_callback(obj, event, handles)
global lektion;
switch lektion
    case 0
        timer_lektion0(handles);                                            % rufe Timerfunktion der Lektion 0 auf
    case 1
        timer_lektion1(handles);                                            % rufe Timerfunktion der Lektion 1 auf
    case 2
        timer_lektion2(handles);                                            % rufe Timerfunktion der Lektion 2 auf
    case 3
        timer_lektion3(handles);                                            % rufe Timerfunktion der Lektion 3 auf
end;



function timer_lektion0(handles)
global kurve_x kurve_y delta_t sliderpos sys1 sys2;
global w_alt1 w_alt2 t regler1 output1 output2;
global x0_1 x0_2 z w1 w2;
global y_speicher sp1_yspeicher sp2_yspeicher z_speicher;
global sp1_fehler sp2_fehler;
global ball1 ball2;
kurve_y = circshift(kurve_y,[0,-1]);                                        % rotiere Sollkurvenvektor nach links
plot(handles.axes1,kurve_x,kurve_y, 'Color','black');                       % plotte verschobene Sollkurve 
sliderpos = get(handles.slider,'Value')*30;                                 % lese zehnfachen Sliderwert ein
if regler1 == 1                                                             % wenn Regler von Spieler1 'manuell'...
    w1 = [w_alt1 sliderpos]';                                               % neue Fhrungsgre Spieler1 = sliderpos
else                                                                        % ansonsten...
    w1 = [w_alt1 kurve_y(21)]';                                             % neue Fhrungsgre Spieler1 = aktueller Sollwert
end;                                                                        % 21stes Element ist aktueller Sollwert
w2 = [w_alt2 kurve_y(21)]';                                                 % neue Fhrungsgre Spieler2 = aktueller Sollwert
t = [0 0.1]';                                                               % Deklaration des Zeitvektors fr Simulation
y_speicher = [y_speicher, kurve_y(21)];                                     % speichere Sollwertverlauf
z_speicher = [z_speicher, 0.01*z(1)];                                       % speichere Strgrenverlauf

[y1,t,x0_1] = lsim(sys1, [z,w1], t, x0_1);                                  % simuliere System fr Spieler1
x0_1 = x0_1(length(x0_1(:,1)),:)';                                          % speichere Ergebnis als Startwert fr nchste Sim

[y2,t,x0_2] = lsim(sys2, [z,w2], t, x0_2);                                  % simuliere System fr Spieler2
x0_2 = x0_2(length(x0_2(:,1)),:)';                                          % speichere Ergebnis als Startwert fr nchste Sim

output1 = y1(length(y1));                                                   % speichern des aktuellen Ausgangs Spieler1
output2 = y2(length(y2));                                                   % speichern des aktuellen Ausgangs Spieler2

sp1_yspeicher = [sp1_yspeicher, output1];                                   % speichern des Ausgangsverlaufs Spieler1
sp1_fehler = sp1_fehler + abs(y_speicher(length(y_speicher)) - output1);    % Summation der Abweichung Spieler1

sp2_yspeicher = [sp2_yspeicher, output2];                                   % speichern des Ausgangsverlaufs Spieler2
sp2_fehler = sp2_fehler + abs(y_speicher(length(y_speicher)) - output2);    % Summation der Abweichung Spieler2
                                                                            % falls Lektion 0 oder 1...       
if regler1 == 1                                                             % wenn Regler Spieler1 = 'manuel'...                                         
    w_alt1 = sliderpos;                                                     % alte Fhrungsgre Spieler1 = sliderpos
else                                                                        % ansonsten...
    w_alt1 = kurve_y(21);                                                   % alte Fhrungsgre Spieler1 = aktueller Sollwert
end;
w_alt2 = kurve_y(21);                                                       % alte Fhrungsgre Spieler2 = aktueller Sollwert
                                                                            % falls Lektion 0 oder 1...
if abs(output1) < 2.5                                                       % wenn Spielfigur1 im anzeigbaren Bereich...
    set(handles.spaceball1,'Position',...                                   % neue Position Spaceball1
    [ball1.x0 ball1.y0+0.076*(round(output1*50)/50)...
    ball1.width ball1.height]);
else                                                                        % ansonsten...
    set(handles.spaceball1,'Position',...                                   % verschiebe Spielfigur1 in nicht sichtbaren Bereich
        [2,ball1.y0,ball1.width,ball1.height]);
end;
if abs(output2) < 2.5                                                       % wenn Spielfigur2 im anzeigbaren Bereich...
    set(handles.spaceball2,'Position',...                                   % neue Position Spaceball2
    [ball2.x0 ball2.y0+0.076*(round(output2*50)/50)...
    ball2.width ball2.height]);
else                                                                        % ansonsten...
    set(handles.spaceball2,'Position',...                                   % verschiebe Spielfigur2 in nicht sichtbaren Bereich
        [2,ball2.y0,ball2.width,ball2.height]);
end;                                                                        
set(handles.zeit, 'String', num2str(round(delta_t - 0.49)));                % zeige Zeitfortschritt an
kometen_schieben(handles);                                                  % zeichne Kometen neu ein
set(handles.axes1, 'XAxisLocation','bottom', 'YAxisLocation','right',...    % Eigenschaften des Plotfensters
    'XLim',[-2 20], 'YLim',[-2.5 2.5]);
kollision_pruefen(output1, output2, handles);                               % berprfe Kollisionen
delta_t = delta_t + 0.1;                                                    % erhhe Zeitfortschritt des Spiels
if delta_t >= 20                                                            % wenn Zeitfortschritt > 20 sec...
    spielergebnis(handles);                                                 % zeige Spielergebnis an
end;
if get(handles.schwierigkeitsmenu, 'Value') == 2                            % wenn Fortgeschrittenenmodus...
    sonnenwind_ermitteln(handles);                                          % ermittle, ob Sonnenwind eingeschaltet wird
end;



function timer_lektion1(handles)
global kurve_x kurve_y delta_t sliderpos sys1 sys2;
global w_alt1 w_alt2 t regler1 output1 output2;
global x0_1 x0_2 z w1 w2;
global y_speicher sp1_yspeicher sp2_yspeicher z_speicher;
global sp1_fehler sp2_fehler;
global ball1 ball2;
kurve_y = circshift(kurve_y,[0,-1]);                                        % rotiere Sollkurvenvektor nach links
plot(handles.axes1,kurve_x,kurve_y, 'Color','black');                       % plotte verschobene Sollkurve 
sliderpos = get(handles.slider,'Value')*30;                                 % lese zehnfachen Sliderwert ein
if regler1 == 1                                                             % wenn Regler von Spieler1 'manuell'...
    w1 = [w_alt1 sliderpos]';                                               % neue Fhrungsgre Spieler1 = sliderpos
else                                                                        % ansonsten...
    w1 = [w_alt1 kurve_y(21)]';                                             % neue Fhrungsgre Spieler1 = aktueller Sollwert
end;                                                                        % 21stes Element ist aktueller Sollwert
w2 = [w_alt2 kurve_y(21)]';                                                 % neue Fhrungsgre Spieler2 = aktueller Sollwert
t = [0 0.1]';                                                               % Deklaration des Zeitvektors fr Simulation

y_speicher = [y_speicher, kurve_y(21)];                                     % speichere Sollwertverlauf
z_speicher = [z_speicher, 0.01*z(1)];                                       % speichere Strgrenverlauf

[y1,t,x0_1] = lsim(sys1, [z,w1], t, x0_1);                                  % simuliere System fr Spieler1
x0_1 = x0_1(length(x0_1(:,1)),:)';                                          % speichere Ergebnis als Startwert fr nchste Sim

[y2,t,x0_2] = lsim(sys2, [z,w2], t, x0_2);                                  % simuliere System fr Spieler2
x0_2 = x0_2(length(x0_2(:,1)),:)';                                          % speichere Ergebnis als Startwert fr nchste Sim

output1 = y1(length(y1));                                                   % speichern des aktuellen Ausgangs Spieler1
output2 = y2(length(y2));                                                   % speichern des aktuellen Ausgangs Spieler2

sp1_yspeicher = [sp1_yspeicher, output1];                                   % speichern des Ausgangsverlaufs Spieler1
sp1_fehler = sp1_fehler + abs(y_speicher(length(y_speicher)) - output1);    % Summation der Abweichung Spieler1

sp2_yspeicher = [sp2_yspeicher, output2];                                   % speichern des Ausgangsverlaufs Spieler2
sp2_fehler = sp2_fehler + abs(y_speicher(length(y_speicher)) - output2);    % Summation der Abweichung Spieler2
if regler1 == 1                                                             % wenn Regler Spieler1 = 'manuel'...                                         
    w_alt1 = sliderpos;                                                     % alte Fhrungsgre Spieler1 = sliderpos
else                                                                        % ansonsten...
    w_alt1 = kurve_y(21);                                                   % alte Fhrungsgre Spieler1 = aktueller Sollwert
end;
w_alt2 = kurve_y(21);                                                       % alte Fhrungsgre Spieler2 = aktueller Sollwert                                                              % falls Lektion 0 oder 1...
if abs(output1) < 2.5                                                       % wenn Spielfigur1 im anzeigbaren Bereich...
    set(handles.spaceball1,'Position',...                                   % neue Position Spaceball1
    [ball1.x0 ball1.y0+0.076*(round(output1*50)/50)...
    ball1.width ball1.height]);
else                                                                        % ansonsten...
    set(handles.spaceball1,'Position',...                                   % verschiebe Spielfigur1 in nicht sichtbaren Bereich
        [2,ball1.y0,ball1.width,ball1.height]);
end;
if abs(output2) < 2.5                                                       % wenn Spielfigur2 im anzeigbaren Bereich...
    set(handles.spaceball2,'Position',...                                   % neue Position Spaceball2
    [ball2.x0 ball2.y0+0.076*(round(output2*50)/50)...
    ball2.width ball2.height]);
else                                                                        % ansonsten...
    set(handles.spaceball2,'Position',...                                   % verschiebe Spielfigur2 in nicht sichtbaren Bereich
        [2,ball2.y0,ball2.width,ball2.height]);
end;
set(handles.zeit, 'String', num2str(round(delta_t - 0.49)));                % zeige Zeitfortschritt an
kometen_schieben(handles);                                                  % zeichne Kometen neu ein
set(handles.axes1, 'XAxisLocation','bottom', 'YAxisLocation','right',...    % Eigenschaften des Plotfensters
    'XLim',[-2 20], 'YLim',[-2.5 2.5]);
kollision_pruefen(output1, output2, handles);                               % berprfe Kollisionen
delta_t = delta_t + 0.1;                                                    % erhhe Zeitfortschritt des Spiels
if delta_t >= 20                                                            % wenn Zeitfortschritt > 20 sec...
    spielergebnis(handles);                                                 % zeige Spielergebnis an
end;
if get(handles.schwierigkeitsmenu, 'Value') == 2                            % wenn Fortgeschrittenenmodus...
    sonnenwind_ermitteln(handles);                                          % ermittle, ob Sonnenwind eingeschaltet wird
end;



function timer_lektion2(handles)
global kurve_x kurve_y delta_t;
global w_alt1 t output1 output2;
global z w1;
global y_speicher sp1_yspeicher sp2_yspeicher z_speicher gamma_speicher;
global nickwinkel_speicher eta_speicher sp1_fehler sp2_fehler;
global shuttle1;
global eta_max;
kurve_y = circshift(kurve_y,[0,-1]);                                        % rotiere Sollkurvenvektor nach links
plot(handles.axes1,kurve_x,kurve_y, 'Color','black');                       % plotte verschobene Sollkurve 
w1 = [w_alt1 kurve_y(21)]';                                                 % neue Fhrungsgre Shuttle = aktueller Sollwert
t = [0 0.1]';                                                               % Deklaration des Zeitvektors fr Simulation
y_speicher = [y_speicher, kurve_y(21)];                                     % speichere Sollwertverlauf
z_speicher = [z_speicher, 0.01*z(1)];                                       % speichere Strgrenverlauf
if (round(delta_t*10)==100)&&(get(handles.lastwechsel, 'Value')==1)         % Wenn Zeitfortschritt=10s und lastwechsel aktiviert...
    assignin('base', 'theta_offset', 5);                                    % speichere neuen gamma-offset im Workspace
    set(handles.axes_shuttle_ohne_lastw, 'Position',...
        [2.0258 0.3667 0.5822 0.481]);
    set(handles.axes_shuttle_mit_lastw, 'Position',...
        [0.0258 0.3667 0.5822 0.481]);    
end;         
if (get(handles.messrauschen, 'Value') == 1)                                % wenn Messrauschen aktiviert...
    assignin('base', 'noise_startvalue', abs(round(100000*rand)));          % bestimme neuen Startwert
end;    
assignin('base', 'slider', get(handles.slider,'Value')*pi/5);
[t,x0,y1] = sim('lektion2_kaskade',t,simset(),[t w1]);                      % simuliere das System

assignin('base', 'lektion2x0_0', x0(2,5));                                  % speichere Zustnde im Workspace
assignin('base', 'lektion2x0_1', x0(2,2));
assignin('base', 'lektion2x0_2', x0(2,3));
assignin('base', 'lektion2x0_3', x0(2,1));
assignin('base', 'lektion2x0_4', x0(2,4));

output1 = y1(2,1);                                                          % speichere Shuttlehhe
shuttle1.nickwinkel = y1(2,2);                                              % speichere Nickwinkel
nickwinkel_speicher = [nickwinkel_speicher, y1(2,2)];                       % speichere Nickwinkel in Speicher fr Nickwinkelverlauf
gamma_speicher = [gamma_speicher, y1(2,3)];                                 % speichere gamma in Speicher fr gamma-Verlauf
eta_speicher = [eta_speicher, y1(2,4)];
output2 = 0;                                                                % setze zweiten Ausgang auf 0 (Spieler 2 existiert nicht)

sp1_yspeicher = [sp1_yspeicher, output1];                                   % speichern des Ausgangsverlaufs Spieler1
sp1_fehler = sp1_fehler + abs(y_speicher(length(y_speicher)) - output1);    % Summation der Abweichung Spieler1

sp2_yspeicher = [sp2_yspeicher, output2];                                   % speichern des Ausgangsverlaufs Spieler2
sp2_fehler = sp2_fehler + abs(y_speicher(length(y_speicher)) - output2);    % Summation der Abweichung Spieler2
w_alt1 = kurve_y(21);                                                       % alte Fhrungsgre Shuttle = aktueller Sollwert
if abs(output1) < 2.5                                                       % wenn Shuttle im anzeigbaren Bereich...
    set(handles.axes_shuttle1,'Position',...                                % neue Position Shuttle
        [shuttle1.x0 shuttle1.y0+0.076*(round(output1*50)/50)...
        shuttle1.width shuttle1.height]);
    nickwinkel_zeichnen(handles);                                           % zeichne Nickwinkel des Shuttles
else                                                                        % ansonsten...
    set(handles.axes_shuttle1, 'Position', [2 shuttle1.y0...
        shuttle1.width shuttle1.height]);                                   % zeichne Shuttle in nicht sichtbaren Bereich
end;
set(handles.zeit, 'String', num2str(round(delta_t - 0.49)));                % zeige Zeitfortschritt an
set(handles.axes1, 'XAxisLocation','bottom', 'YAxisLocation','right',...    % Eigenschaften des Plotfensters
    'XLim',[-2 20], 'YLim',[-2.5 2.5]);
delta_t = delta_t + 0.1;                                                    % erhhe Zeitfortschritt des Spiels

if eta_max < inf
    axes(handles.axes_eta);
    cla;
    eta_max_x = -2*cos(eta_max);
    eta_max_y = 2*sin(eta_max);
    line([eta_max_x 0],[eta_max_y 0], 'LineWidth', 1, 'Color', 'red');
    line([eta_max_x 0],[-eta_max_y 0], 'LineWidth', 1, 'Color', 'red');

    eta_ist = -y1(2,4);
    eta_ist_x = -cos(eta_ist);
    eta_ist_y = sin(eta_ist);
    line([eta_ist_x 0],[eta_ist_y 0], 'LineWidth',2, 'Color', 'black');
end;

if delta_t >= 20                                                            % wenn Zeitfortschritt > 20 sec...
    spielergebnis(handles);                                                 % zeige Spielergebnis an
end;



function timer_lektion3(handles)
global kurve_y delta_t;
global w_alt1 t output1 output2;
global z w1;
global y_speicher sp1_yspeicher z_speicher gamma_speicher;
global nickwinkel_speicher h_p_speicher;
global shuttle1;
w1 = [0 0]';                                                                % es wird kein Eingang bentigt.Startwert von h ist Eingang
t = [0 0.1]';                                                               % Deklaration des Zeitvektors fr Simulation
y_speicher = [y_speicher, kurve_y(21)];                                     % speichere Sollwertverlauf
z_speicher = [z_speicher, 0.01*z(1)];                                       % speichere Strgrenverlauf
assignin('base', 'slider', 1/4*get(handles.slider,'Value')*pi/5);

[t,x0,y1] = sim('lektion3_lqr',t,simset(), [t w1]);                         % simuliere das System
assignin('base', 'lektion3x0_0', x0(2,4));                                  % speichere Zustnde im Workspace
assignin('base', 'lektion3x0_1', x0(2,2));
assignin('base', 'lektion3x0_2', x0(2,3));
assignin('base', 'lektion3x0_3', x0(2,1));
output1 = y1(2,1);                                                          % speichere Shuttlehhe
shuttle1.nickwinkel = 50 * y1(2,2);                                         % speichere bertrieben dargestellten Nickwinkel fr Veranschaulichung
nickwinkel_speicher = [nickwinkel_speicher, y1(2,2)];                       % speichere Nickwinkel in Speicher fr Nickwinkelverlauf
gamma_speicher = [gamma_speicher, y1(2,3)];                                 % speichere gamma in Speicher fr gamma-Verlauf
h_p_speicher = [h_p_speicher, y1(2,4)];                                     % speichere Steiggeschwindigkeit h(p)
output2 = 0;                                                                % setze zweiten Ausgang auf 0 (Spieler 2 existiert nicht)

sp1_yspeicher = [sp1_yspeicher, output1];                                   % speichern des Ausgangsverlaufs Spieler1

w_alt1 = 0;                                                                 % wird bei lqr nicht bentigt
if (output1 > -0.5) && (output1 < 4.5)                                      % wenn Shuttle im anzeigbaren Bereich...
    set(handles.axes_shuttle1,'Position',...                                % neue Position Shuttle
        [shuttle1.x0 shuttle1.y0-0.152+0.076*(round(output1*50)/50)...
        shuttle1.width shuttle1.height]);
    nickwinkel_zeichnen(handles);                                           % zeichne Nickwinkel des Shuttles
else                                                                        % ansonsten...
    set(handles.axes_shuttle1, 'Position', [2 shuttle1.y0...
        shuttle1.width shuttle1.height]);                                   % zeichne Shuttle in nicht sichtbaren Bereich
end;
if output1 < 0                                                              % wenn Shuttle gelandet ist...
    set(handles.axes_shuttle1,'Position',...                                % zeichne Shuttle auf Landebahn ein
        [shuttle1.x0 0.5 shuttle1.width shuttle1.height]);
end;
set(handles.zeit, 'String', num2str(round(delta_t - 0.49)));                % zeige Zeitfortschritt an
set(handles.axes1, 'XAxisLocation','bottom', 'YAxisLocation','right',...    % Eigenschaften des Plotfensters
    'XLim',[-400+delta_t*200 4000+delta_t*200], 'YLim',[-50 450]);
delta_t = delta_t + 0.1;                                                    % erhhe Zeitfortschritt des Spiels

delta_x = 0.003757;                                                         % Landebahn kommt nach jedem Zeitschritt um delta_x nher
pos_dummy = get(handles.axes39, 'Position');                                % lese Position der Landebahn ein
pos_dummy(1) = pos_dummy(1) - delta_x;                                      % berechne neue Position
set(handles.axes39, 'Position', pos_dummy);                                 % zeichne Landebahn in neue Position ein

if (output1 <= 0) || (delta_t >= 20)                                        % wenn Zeitfortschritt > 20 sec...
    spielergebnis(handles);                                                 % zeige Spielergebnis an
end;

    



function nickwinkel_zeichnen(handles)
global shuttle1;                                  
if abs(shuttle1.nickwinkel) < 90                                            % wenn Nickwinkel kleiner 90 ...
    shuttle1.nickwinkel = round(shuttle1.nickwinkel/10)*10;                 % berechne Nickwinkel auf 10 genau
else                                                                        % ansonsten...
    if shuttle1.nickwinkel >= 90                                            % wenn Nickwinkel >= 90...
        shuttle1.nickwinkel = 90;                                           % setze Nickwinkel auf 90
    end;
    if shuttle1.nickwinkel <= -90                                           % wenn Nickwinkel <= -90...
        shuttle1.nickwinkel = -90;                                          % setze Nickwinkel auf -90
    end; 
end;
if abs(shuttle1.nickwinkel - shuttle1.nickwinkel_alt) >= 10                 % falls Nickwinkelnderung >= 10
    switch shuttle1.nickwinkel                                              % unterscheide zwischen Nickwinkeln...
        case 0                                                              % falls Nickwinkel gleich 0...
            shuttle1_bild=shuttle1.p0;                                      % speichere passendes Shuttle-Bild
            shuttle1_trans=shuttle1.p0trans;                                % speichere passendes transparentes Shuttle-Bild
        case 10                                                             % usw...
            shuttle1_bild=shuttle1.p10;
            shuttle1_trans=shuttle1.p10trans;
        case 20
            shuttle1_bild=shuttle1.p20;
            shuttle1_trans=shuttle1.p20trans;
        case 30
            shuttle1_bild=shuttle1.p30;
            shuttle1_trans=shuttle1.p30trans;
        case 40
            shuttle1_bild=shuttle1.p40;
            shuttle1_trans=shuttle1.p40trans;
        case 50
            shuttle1_bild=shuttle1.p50;
            shuttle1_trans=shuttle1.p50trans;
        case 60
            shuttle1_bild=shuttle1.p60;
            shuttle1_trans=shuttle1.p60trans;
        case 70
            shuttle1_bild=shuttle1.p70;
            shuttle1_trans=shuttle1.p70trans;
        case 80
            shuttle1_bild=shuttle1.p80;
            shuttle1_trans=shuttle1.p80trans;
        case 90
            shuttle1_bild=shuttle1.p90;
            shuttle1_trans=shuttle1.p90trans;
        case -10
            shuttle1_bild=shuttle1.m10;
            shuttle1_trans=shuttle1.m10trans;
        case -20
            shuttle1_bild=shuttle1.m20;
            shuttle1_trans=shuttle1.m20trans;
        case -30
            shuttle1_bild=shuttle1.m30;
            shuttle1_trans=shuttle1.m30trans;
        case -40
            shuttle1_bild=shuttle1.m40;
            shuttle1_trans=shuttle1.m40trans;
        case -50
            shuttle1_bild=shuttle1.m50;
            shuttle1_trans=shuttle1.m50trans;
        case -60
            shuttle1_bild=shuttle1.m60;
            shuttle1_trans=shuttle1.m60trans;
        case -70
            shuttle1_bild=shuttle1.m70;
            shuttle1_trans=shuttle1.m70trans;
        case -80
            shuttle1_bild=shuttle1.m80;
            shuttle1_trans=shuttle1.m80trans;
        case -90
            shuttle1_bild=shuttle1.m90;
            shuttle1_trans=shuttle1.m90trans;
    end;
    axes(handles.axes_shuttle1);                                            % lege aktuelles Plotfenster fest
    shuttle1_plot = image(shuttle1_bild);                                   % zeige gespeichertes Bild an
    set(handles.axes_shuttle1, 'Visible', 'off');                           % blende Achsenbeschriftung aus
    set(shuttle1_plot,'AlphaData',shuttle1_trans);                          % mache das Bild transparent
    shuttle1.nickwinkel_alt = shuttle1.nickwinkel;                          % speichere neuen Nickwinkel als alten
end;






function lade_shuttle_bilder(handles)
global shuttle1;
plot_position = get(handles.axes_shuttle1, 'Position');                     % lese Position des Shuttles ein

[dummy_p0 dummy_0 dummy_transparent_p0] = imread('shuttle1p0.png');         % lese Shuttlebilder komponentenweise ein
[dummy_p10 dummy_0 dummy_transparent_p10] = imread('shuttle1p10.png');
[dummy_p20 dummy_0 dummy_transparent_p20] = imread('shuttle1p20.png');
[dummy_p30 dummy_0 dummy_transparent_p30] = imread('shuttle1p30.png');
[dummy_p40 dummy_0 dummy_transparent_p40] = imread('shuttle1p40.png');
[dummy_p50 dummy_0 dummy_transparent_p50] = imread('shuttle1p50.png');
[dummy_p60 dummy_0 dummy_transparent_p60] = imread('shuttle1p60.png');
[dummy_p70 dummy_0 dummy_transparent_p70] = imread('shuttle1p70.png');
[dummy_p80 dummy_0 dummy_transparent_p80] = imread('shuttle1p80.png');
[dummy_p90 dummy_0 dummy_transparent_p90] = imread('shuttle1p90.png');
[dummy_m10 dummy_0 dummy_transparent_m10] = imread('shuttle1m10.png');
[dummy_m20 dummy_0 dummy_transparent_m20] = imread('shuttle1m20.png');
[dummy_m30 dummy_0 dummy_transparent_m30] = imread('shuttle1m30.png');
[dummy_m40 dummy_0 dummy_transparent_m40] = imread('shuttle1m40.png');
[dummy_m50 dummy_0 dummy_transparent_m50] = imread('shuttle1m50.png');
[dummy_m60 dummy_0 dummy_transparent_m60] = imread('shuttle1m60.png');
[dummy_m70 dummy_0 dummy_transparent_m70] = imread('shuttle1m70.png');
[dummy_m80 dummy_0 dummy_transparent_m80] = imread('shuttle1m80.png');
[dummy_m90 dummy_0 dummy_transparent_m90] = imread('shuttle1m90.png');

shuttle1 = struct('p0',dummy_p0,...                                         % speichere die Shuttlebilder
    'p10',dummy_p10,...                                                     % von -90 bis +90 in Struktur shuttle1
    'p20',dummy_p20,...
    'p30',dummy_p30,...
    'p40',dummy_p40,...
    'p50',dummy_p50,...
    'p60',dummy_p60,...
    'p70',dummy_p70,... 
    'p80',dummy_p80,...
    'p90',dummy_p90,...
    'm10',dummy_m10,...
    'm20',dummy_m20,...
    'm30',dummy_m30,...
    'm40',dummy_m40,...
    'm50',dummy_m50,...
    'm60',dummy_m60,...
    'm70',dummy_m70,...
    'm80',dummy_m80,...
    'm90',dummy_m90,...
    'p0trans',dummy_transparent_p0,...                                      % speichere die Transparenzdaten 
    'p10trans',dummy_transparent_p10,...
    'p20trans',dummy_transparent_p20,...
    'p30trans',dummy_transparent_p30,...
    'p40trans',dummy_transparent_p40,...
    'p50trans',dummy_transparent_p50,...
    'p60trans',dummy_transparent_p60,...
    'p70trans',dummy_transparent_p70,...
    'p80trans',dummy_transparent_p80,...
    'p90trans',dummy_transparent_p90,...
    'm10trans',dummy_transparent_m10,...
    'm20trans',dummy_transparent_m20,...
    'm30trans',dummy_transparent_m30,...
    'm40trans',dummy_transparent_m40,...
    'm50trans',dummy_transparent_m50,...
    'm60trans',dummy_transparent_m60,...
    'm70trans',dummy_transparent_m70,...
    'm80trans',dummy_transparent_m80,...
    'm90trans',dummy_transparent_m90,...
    'nickwinkel',0,...                                                      % Anfangsnickwinkel = 0
    'nickwinkel_alt',0,...
    'x0',0.1427,...                                                         % Anfangspositionen
    'y0',0.6523,...
    'width',plot_position(3),...
	'height',plot_position(4));                                                                
    




function sonnenwind_ermitteln(handles)
global sonnenwind sonnenwindpos sonnenwindneg z;
if rand > 0.97                                                              % wenn bestimmte Wahrscheinlichkeit...
    if sonnenwind == 0                                                      % wenn Sonnenwind deaktiviert ist...
        if rand > 0.5                                                       % wenn 50%-50% Chance...
            sonnenwind = 40;                                                % setze Sonnenwind auf +40
            axes(handles.axes2);                                            % zeige Sonnenwindbild im unteren
            image(sonnenwindpos);                                           % Fenster an
            set(handles.axes2, 'Visible', 'off');                           % blende Achsenbeschriftung aus
        else                                                                % ...ansonsten...
            sonnenwind = -40;                                               % setze Sonnenwind auf -40
            axes(handles.axes3);                                            % zeige Sonnenwindbild im oberen
            image(sonnenwindneg);                                           % Fenster an
            set(handles.axes3, 'Visible', 'off');                           % blende Achsenbeschriftung aus
        end;
    else                                                                    % ...ansonsten...
        sonnenwind = 0;                                                     % setze Sonnenwind auf 0
        cla(handles.axes2);                                                 % lsche beide Sonnenwindanzeigen
        cla(handles.axes3);
    end;
    z = [sonnenwind, sonnenwind]';                                          % speichere Sonnenwind als Strgre
end;





function spielergebnis(handles)
global ttimer x_speicher y_speicher sp1_yspeicher sp2_yspeicher z_speicher;
global gamma_speicher sp1_fehler sp2_fehler delta_t lektion;
global nickwinkel_speicher eta_speicher h_p_speicher;
stop(ttimer);                                                               % stoppe Timer
delete(ttimer);                                                             % lsche Timer
set(handles.slider, 'Value', 0);                                            % Startposition des Sliders
set(handles.Startbutton, 'Enable', 'on');                                   % aktiviere Startbutton
set(handles.Pausebutton, 'Enable', 'off');                                  % deaktiviere Pausebutton
set(handles.Stopbutton, 'Enable', 'off');                                   % deaktiviere Stopbutton
startbildschirm_zeichnen(lektion, handles);                                 % zeichne Startbildschirm neu

x_speicher = 0:0.1:20;                                                      % definiere x-Werte des Sollverlaufs
figure('units','normalized','outerposition',[0 0.1 1 0.9])                  % ffne weiteres Fenster
switch lektion                                                              % unterscheide zwischen Lektionen...
    case {0,1}                                                              % falls Lektion 0 oder 1...
        plot(x_speicher,y_speicher, 'Color','black', 'LineWidth',2);        % plotte Sollverlauf
        set(gca, 'XLim',[-1 21], 'YLim',[-2.5 2.5]);                        % stelle Achsenverhltnisse ein
        hold on;                                                            % aktiviere Graphikberlagerung
        plot(x_speicher,0*x_speicher, 'Color','black');                     % zeichne Nulllinie
        plot(x_speicher,sp1_yspeicher, 'r--');                              % plotte Ausgangsverlauf Spieler1
        plot(x_speicher,sp2_yspeicher, 'b--');                              % plotte Ausgangsverlauf Spieler2
        plot(x_speicher,z_speicher, 'g--');                                 % plotte Verlauf der Strgre
        legend('Sollkurve','Nulllinie','Spieler1','Spieler2',...            % Legende fr Zuweisung der Kurven
            'Sonnenwind',5);
        if sp1_fehler < sp2_fehler                                          % wenn Fehler von Spieler1 < Spieler2...
            xlabel(['Spieler 1 (Abweichung: ',num2str(sp1_fehler),...       % gebe Spielergebnis aus
            ') hat gegen Spieler 2 (Abweichung: ',num2str(sp2_fehler),...
            ') gewonnen !']);
        end;
        if sp1_fehler > sp2_fehler                                          % wenn Fehler von Spieler1 > Spieler2...
            xlabel(['Spieler 2 (Abweichung: ',num2str(sp2_fehler),...       % gebe Spielergebis aus
                ') hat gegen Spieler 1 (Abweichung: ',...
                num2str(sp1_fehler),') gewonnen !']);
        end;
        if sp1_fehler == sp2_fehler                                         % wenn unentschieden...
            xlabel(['Das Spiel ist unentschieden ausgegangen. Beide ',...   % gebe Spielergebnis aus
               'Spieler haben eine Abweichung von: ',num2str(sp1_fehler)]);
        end;
    case 2                                                                  % falls Lektion 2...
        plot(x_speicher,y_speicher, 'Color','black', 'LineWidth',2);        % plotte Sollverlauf
        set(gca, 'XLim',[-1 21], 'YLim',[-2.5 2.5]);                        % stelle Achsenverhltnisse ein
        hold on;                                                            % aktiviere Graphikberlagerung
        plot(x_speicher,0*x_speicher, 'Color','black');                     % zeichne Nulllinie
        plot(x_speicher,sp1_yspeicher, 'r--');                              % plotte Ausgangsverlauf Shuttle 
        plot(x_speicher,gamma_speicher/10, 'b--');                          % zeichne gamma-Verlauf
        plot(x_speicher,nickwinkel_speicher/10,'m--');                      % zeichne Nickwinkel-Verlauf
        K_r_aussen_offen = str2num(get(handles.K_r_aussen, 'String'));      % speichere K_r auen
        G_aussen_offen = tf([K_r_aussen_offen*200],[1 0]);                  % berechne -Fkt des ueren offenen Kreises ohne inneren Kreis
        G_aussen = feedback(G_aussen_offen,1);                              % berechne -Fkt des ueren geschlossenen Kreises ohne innen
        [y_aussen,t_a,x_a] = lsim(G_aussen, y_speicher, x_speicher, 0);     % simuliere den ueren Kreis
        plot(x_speicher,y_aussen, 'g--');                                   % zeichne Ausgang fr ueren Kreis
           
        xlabel(['Spieler 1 (Abweichung: ',num2str(sp1_fehler),')']);        % gebe Spielergebnis aus      
        if (get(handles.radiobutton_umax, 'Value') == 1)
            plot(x_speicher,eta_speicher,'c--');
            legend('Sollkurve','Nulllinie','Hhe (Shuttle)',...                 % zeige Legende fr Kurvenzuweisung an
                'Gamma (Shuttle) [10rad]','Nickwinkel (Shuttle) [10rad]',...
                ['Hhe (Shuttle) ohne inneren Kreis, Merauschen, ',...
                'Lastwechsel und Stellgrenbeschrnkung'],...
                'Hhenruder eta [rad]');
            sim_lektion2_awup();
        else
            legend('Sollkurve','Nulllinie','Hhe (Shuttle)',...            % zeige Legende fr Kurvenzuweisung an
                'Gamma (Shuttle) [10rad]','Nickwinkel (Shuttle) [10rad]',...
                ['Hhe (Shuttle) ohne inneren Kreis, Merauschen, ',...
                'Lastwechsel und Stellgrenbeschrnkung']);
        end;
    case 3                                                                  % falls Lektion 3...      
        if h_p_speicher(length(h_p_speicher)) < (-1.5)                      % falls Sinkgeschwindigkeit bei Landung ok...                      
            ergebnis2 = [' Die maximale Sinkgeschwindigkeit bei der'...     % speichere Ergebnis
                ' Landung von 1,5 m/s wurde berschritten.'];
        else                                                                % ansonsten...
            ergebnis2 = [' Die maximale Sinkgeschwindigkeit bei der'...     % speichere Ergebnis
                ' Landung von 1,5 m/s wurde eingehalten.'];
        end;
        if get(handles.lektion3_button_h,'value') == 1                      % falls nur Hhe gewichtet wurde...
            ergebnis2 = '';                                                 % lsche 2ten Teil des Ergebnisses
        end;       
        if delta_t < 18.4                                                   % falls das Shuttle zu frh gelandet ist...
            ergebnis1 = 'Das Shuttle ist zu frh gelandet!';                % speichere Ergebnis
            ergebnis_farbe = 'r';
            sound_landung = wavread('shuttle_absturz');                     % lade Absturzgerusch
        end;
        if (delta_t >= 18.4) && (delta_t <= 19.1)                           % falls das Shuttle im erlaubten Bereich gelandet ist...
            ergebnis1 ='Das Shuttle ist an der richtigen Stelle gelandet!'; % speichere Ergebnis
            if (get(handles.lektion3_button_h_p,'Value')==1) &&...          % falls Steiggeschwindigkeit gewichtet wurde und
                (h_p_speicher(length(h_p_speicher)) < (-1.5))               % diese bei der Landung nicht ok ist...
                ergebnis_farbe = 'r';
                sound_landung = wavread('shuttle_absturz');                 % lese Absturzgerusch
            else                                                            % ansonsten...
                ergebnis_farbe = 'b';
                sound_landung = wavread('shuttle_landung');                 % lade Landungsgerusch
            end;         
        end;
        if delta_t > 19.1                                                   % falls das Shuttle zu spt gelandet ist...
            ergebnis1 = 'Das Shuttle ist zu spt gelandet!';                % speichere Ergebnis
            ergebnis_farbe = 'r';
            ergebnis2 = '';                                                 % lsche 2ten Ergebnisteil
            sound_landung = wavread('shuttle_absturz');                     % lade Absturzgerusch
        end;      
        if (strcmp(computer,'PCWIN')) || (strcmp(computer,'PCWIN64'))       % falls Windowsplattform genutzt wird...
            wavplay(sound_landung,4*8192);                                  % gebe Landungs-/Absturzgerusch aus
        end;                                                                % (bei Linux gibt es mit wavplay Probleme!)
        plot(x_speicher,0*x_speicher, 'Color','black');                     % zeichne Nulllinie
        set(gca, 'XLim',[-1 21], 'YLim',[-5.5 4.5]);                        % stelle Achsenverhltnisse ein
        hold on;                                                            % aktiviere Graphikberlagerung       
        plot(x_speicher(1,[2:round(delta_t*10+1)]),...                      % plotte Ausgangsverlauf Shuttle
            sp1_yspeicher(1,[2:length(sp1_yspeicher)]), 'r--');                               
        plot(x_speicher(1,[1:round(delta_t*10+1)]),gamma_speicher, 'b--');  % zeichne gamma-Verlauf
        plot(x_speicher(1,[1:round(delta_t*10+1)]),...                      % zeichne Nickwinkel-Verlauf
            nickwinkel_speicher,'m--');
        plot(x_speicher(1,[1:round(delta_t*10+1)]),...                      % zeichne Steiggeschwindigkeit
            h_p_speicher/10, 'g--');       
        legend('Nulllinie','Hhe',...                                       % zeige Legende fr Kurvenzuweisung an
            'Gamma [Grad]','Nickwinkel [Grad]',...
            'Steiggeschwindigkeit [10m/s]',5);   
        title(['Die Sinkgeschwindigkeit bei der Landung betrgt: ',...      % Zeige Sinkgeschwindigkeit bei Landung als Titel an
            num2str(-h_p_speicher(length(h_p_speicher))),' [m/s]']);
        xlabel([ergebnis1,ergebnis2],'FontSize',12,'Color',ergebnis_farbe); % Zeige das Ergebnis als xlabel an
end;
delta_t = 0;                                                                % setze Zeitfortschritt auf 0
hold off;                                                                   % deaktiviere Graphikberlagerung
eingabefenster('on', handles);                                              % Eingabefenster aktivieren





function sim_lektion2_awup()
assignin('base', 'lektion2x0_0', 0);                                        % speichere Startzustnde in Workspace
assignin('base', 'lektion2x0_1', 0);
assignin('base', 'lektion2x0_2', 0);
assignin('base', 'lektion2x0_3', 0);
assignin('base', 'lektion2x0_4', 0);
assignin('base', 'theta_offset', 0);
assignin('base', 'noise_power', 0);
w1 = [1 1]';
t = [0 100]';
[t,x0,y1] = sim('lektion2_kaskade',t,simset(),[t w1]);                      % simuliere das System
figure();
plot(t, ones(length(t),1), 'b');
hold on;
plot(t, y1(:,1), 'r');
hold off;
title(['Simulation ber 100 Sekunden fr eine sprungfrmige ',...
    'Hhennderung ohne Lastwechsel']);
legend('Sollhhe', 'Hhe des Shuttles');




function kometen_berechnen(kurve, handles)
global kometen;
kometen = ones(5,20);                                                       % Besetzte Kometenmatrix mit Einsen
for zaehler = 21:20:421                                                     % fr Kometenpositionen auf kurve projektiert
    kometen(3-round(kurve(zaehler)+0.51),(zaehler-1)/20)=0;                 % lsche 2 Kometen, die in der Nhe der
    kometen(3-round(kurve(zaehler)-0.49),(zaehler-1)/20)=0;                 % Sollkurve liegen
end;
anz_kometen = 60;                                                           % Anzahl der Einsen in Matrix = 60
while (anz_kometen > 10)                                                    % solange bis Anzahl der Einsen = 10...    
    for zaehler1 = 1:21                                                     % alle brigen Kometen der 21 Spalten...
        for zaehler2 = 1:5                                                  % und 5 Reihen...
            if kometen(zaehler2, zaehler1) == 1                             % falls Komet aktiviert...
                if rand > 0.5                                               % falls Wahrscheinlichkeit von 50%...
                    kometen(zaehler2, zaehler1) = 0;                        % deaktiviere Komet
                    anz_kometen = anz_kometen -1;                           % dekrementiere Anzahl der Kometen
                    if (anz_kometen == 10) break;                           % falls nur noch 10 Kometen aktiviert...
                    end;                                                    % verlasse die Schleife
                end;
                if (anz_kometen == 10) break;                               % falls nur noch 10 Kometen aktiviert...
                end;                                                        % verlasse die Schleife
            end;            
        end;
        if (anz_kometen == 10) break;                                       % falls nur noch 10 Kometen aktiviert...
        end;                                                                % verlasse die Schleife
    end;
end;




function kometen_zeichnen(handles)
global kometen kometen_gitter_x kometen_gitter_y;
global kometen_pos_x kometen_pos_y kometen_width kometen_height;

[bild_komet dummy bild_komet_trans] = imread('komet.png');                  % lese Kometenbild ein 

axes(handles.komet01);                                                      % lege aktuelles Plot-Fenster fest
komet1_plot = image(bild_komet);                                            % zeige Komet1 an
set(handles.komet01, 'Visible', 'off');                                     % blende Achsenbeschriftung aus
set(komet1_plot, 'AlphaData', bild_komet_trans);                            % mache Bildhintergrund transparent

axes(handles.komet02);                                                      % (wie bei Komet1)
komet2_plot = image(bild_komet);                                                               
set(handles.komet02, 'Visible', 'off'); 
set(komet2_plot, 'AlphaData', bild_komet_trans);

axes(handles.komet03);                                                    
komet3_plot = image(bild_komet);                                                               
set(handles.komet03, 'Visible', 'off'); 
set(komet3_plot, 'AlphaData', bild_komet_trans);

axes(handles.komet04);                                                    
komet4_plot = image(bild_komet);                                                               
set(handles.komet04, 'Visible', 'off'); 
set(komet4_plot, 'AlphaData', bild_komet_trans);

axes(handles.komet05);                                                    
komet5_plot = image(bild_komet);                                                               
set(handles.komet05, 'Visible', 'off'); 
set(komet5_plot, 'AlphaData', bild_komet_trans);

axes(handles.komet06);                                                    
komet6_plot = image(bild_komet);                                                               
set(handles.komet06, 'Visible', 'off'); 
set(komet6_plot, 'AlphaData', bild_komet_trans);

axes(handles.komet07);                                                    
komet7_plot = image(bild_komet);                                                               
set(handles.komet07, 'Visible', 'off'); 
set(komet7_plot, 'AlphaData', bild_komet_trans);

axes(handles.komet08);                                                    
komet8_plot = image(bild_komet);                                                               
set(handles.komet08, 'Visible', 'off'); 
set(komet8_plot, 'AlphaData', bild_komet_trans);

axes(handles.komet09);                                                    
komet9_plot = image(bild_komet);                                                               
set(handles.komet09, 'Visible', 'off'); 
set(komet9_plot, 'AlphaData', bild_komet_trans);

axes(handles.komet10);                                                    
komet10_plot = image(bild_komet);                                                               
set(handles.komet10, 'Visible', 'off'); 
set(komet10_plot, 'AlphaData', bild_komet_trans);

kometen_gitter_x = [0.1865 0.2615 0.3375 0.4135 0.4895 ...                  % Definition der Kometen-Startpositionen in x-Richtung
    0.5655 0.6415 0.7175 0.7935 0.8695...
    0.9445 1.0205 1.0965 1.1725 1.2485...
    1.3245 1.4005 1.4765 1.5525 1.6285...
    1.7045];
kometen_gitter_y = [0.8646 0.7877 0.7108 0.6354 0.5585];                    % Definition der Kometen-Startpositionen in y-Richtung

kometen_pos = get(handles.komet01, 'Position');                             % lese Position von Komet 1 ein
kometen_width = kometen_pos(3);                                             % speichere Breite
kometen_height = kometen_pos(4);                                            % speichere Hhe
kometenzaehler = 1;                                                         
komet_unsichtbar = 0;                                                       % Merker fr Kometen auerhalb des sichtbaren Bereichs
for zaehler1 = 1:21                                                         % fr alle Kometen in x-Richtung...
    for zaehler2 = 1:5                                                      % und in y-Richtung...
        if kometen(zaehler2, zaehler1) == 1                                 % falls Komet aktiviert ist...
            if (zaehler1 >= 11)                                             % falls Komet im nicht sichtbaren Bereich...
                komet_unsichtbar = 2;                                       % Merker als Multiplikator mit 2 belegen
            end;
            switch kometenzaehler                                           % unterscheide zwischen den Kometen...
                case 1                                                      % falls Komet1...
                    set(handles.komet01,'Position',...                      % verschiebe Komet1 eventl. in nicht sichbareb Bereich 
                        [kometen_gitter_x(zaehler1),...
                        kometen_gitter_y(zaehler2)+komet_unsichtbar,...
                        kometen_width,kometen_height]);
                    kometen_pos_x(1) = kometen_gitter_x(zaehler1);          % speichere Kometen-Position in x-Richtung
                    kometen_pos_y(1) = kometen_gitter_y(zaehler2);          % speichere Kometen-Position in y-Richtung
                case 2  
                    set(handles.komet02,'Position',...                      % (wie bei Komet1)
                        [kometen_gitter_x(zaehler1),...
                        kometen_gitter_y(zaehler2)+komet_unsichtbar,...
                        kometen_width,kometen_height]);
                    kometen_pos_x(2) = kometen_gitter_x(zaehler1);
                    kometen_pos_y(2) = kometen_gitter_y(zaehler2);
                case 3
                    set(handles.komet03,'Position',...
                        [kometen_gitter_x(zaehler1),...
                        kometen_gitter_y(zaehler2)+komet_unsichtbar,...
                        kometen_width,kometen_height]);
                    kometen_pos_x(3) = kometen_gitter_x(zaehler1);
                    kometen_pos_y(3) = kometen_gitter_y(zaehler2);
                case 4
                    set(handles.komet04,'Position',...
                        [kometen_gitter_x(zaehler1),...
                        kometen_gitter_y(zaehler2)+komet_unsichtbar,...
                        kometen_width,kometen_height]);
                    kometen_pos_x(4) = kometen_gitter_x(zaehler1);
                    kometen_pos_y(4) = kometen_gitter_y(zaehler2);
                case 5
                    set(handles.komet05,'Position',...
                        [kometen_gitter_x(zaehler1),...
                        kometen_gitter_y(zaehler2)+komet_unsichtbar,...
                        kometen_width,kometen_height]);
                    kometen_pos_x(5) = kometen_gitter_x(zaehler1);
                    kometen_pos_y(5) = kometen_gitter_y(zaehler2);
                case 6
                    set(handles.komet06,'Position',...
                        [kometen_gitter_x(zaehler1),...
                        kometen_gitter_y(zaehler2)+komet_unsichtbar,...
                        kometen_width,kometen_height]);
                    kometen_pos_x(6) = kometen_gitter_x(zaehler1);
                    kometen_pos_y(6) = kometen_gitter_y(zaehler2);
                case 7
                    set(handles.komet07,'Position',...
                        [kometen_gitter_x(zaehler1),...
                        kometen_gitter_y(zaehler2)+komet_unsichtbar,...
                        kometen_width,kometen_height]);
                    kometen_pos_x(7) = kometen_gitter_x(zaehler1);
                    kometen_pos_y(7) = kometen_gitter_y(zaehler2);
                case 8
                    set(handles.komet08,'Position',...
                        [kometen_gitter_x(zaehler1),...
                        kometen_gitter_y(zaehler2)+komet_unsichtbar,...
                        kometen_width,kometen_height]);
                    kometen_pos_x(8) = kometen_gitter_x(zaehler1);
                    kometen_pos_y(8) = kometen_gitter_y(zaehler2);
                case 9
                    set(handles.komet09,'Position',...
                        [kometen_gitter_x(zaehler1),...
                        kometen_gitter_y(zaehler2)+komet_unsichtbar,...
                        kometen_width,kometen_height]);
                    kometen_pos_x(9) = kometen_gitter_x(zaehler1);
                    kometen_pos_y(9) = kometen_gitter_y(zaehler2);
                case 10
                    set(handles.komet10,'Position',...
                        [kometen_gitter_x(zaehler1),...
                        kometen_gitter_y(zaehler2)+komet_unsichtbar,...
                        kometen_width,kometen_height]);          
                    kometen_pos_x(10) = kometen_gitter_x(zaehler1);
                    kometen_pos_y(10) = kometen_gitter_y(zaehler2);
            end;         
            kometenzaehler = kometenzaehler + 1;                            % inkrementiere Kometenzhler
        end;            
    end;
end;





function kometen_schieben(handles)
global kometen_pos_x kometen_pos_y kometen_width kometen_height;
delta_x = 0.003757;                                                         % Kometen werden alle 0,1s um 0,003757 Prozent verschoben

for zaehler=1:10                                                            % fr alle Kometen...
    kometen_pos_x(zaehler) = kometen_pos_x(zaehler) - delta_x;              % speichere neue Kometenposition
    if (kometen_pos_x(zaehler)<0.124)||(kometen_pos_x(zaehler)>0.9313)      % falls Komet in unsichtbarem Bereich...
        kometen_unsichtbar(zaehler) = 2;                                    % setze Positions-Multiplikator auf 2
    else                                                                    % ansonsten...
        kometen_unsichtbar(zaehler) = 0;                                    % setze Positions-Multiplikator auf 0
    end;
end;

set(handles.komet01, 'Position', [kometen_pos_x(1),...                      % zeige die neue Kometenpositionen an
    kometen_pos_y(1)+kometen_unsichtbar(1),kometen_width,kometen_height]);

set(handles.komet02, 'Position', [kometen_pos_x(2),...
    kometen_pos_y(2)+kometen_unsichtbar(2),kometen_width,kometen_height]);

set(handles.komet03, 'Position', [kometen_pos_x(3),...
    kometen_pos_y(3)+kometen_unsichtbar(3),kometen_width,kometen_height]);

set(handles.komet04, 'Position', [kometen_pos_x(4),...
    kometen_pos_y(4)+kometen_unsichtbar(4),kometen_width,kometen_height]);

set(handles.komet05, 'Position', [kometen_pos_x(5),...
    kometen_pos_y(5)+kometen_unsichtbar(5),kometen_width,kometen_height]);

set(handles.komet06, 'Position', [kometen_pos_x(6),...
    kometen_pos_y(6)+kometen_unsichtbar(6),kometen_width,kometen_height]);

set(handles.komet07, 'Position', [kometen_pos_x(7),...
    kometen_pos_y(7)+kometen_unsichtbar(7),kometen_width,kometen_height]);

set(handles.komet08, 'Position', [kometen_pos_x(8),...
    kometen_pos_y(8)+kometen_unsichtbar(8),kometen_width,kometen_height]);

set(handles.komet09, 'Position', [kometen_pos_x(9),...
    kometen_pos_y(9)+kometen_unsichtbar(9),kometen_width,kometen_height]);

set(handles.komet10, 'Position', [kometen_pos_x(10),...
    kometen_pos_y(10)+kometen_unsichtbar(10),kometen_width,kometen_height]);





function kometen_verbergen(handles)
global kometen_pos_y kometen_width kometen_height;
set(handles.komet01, 'Position', [2,kometen_pos_y(1),...                    % verschiebe Kometenpositionen in
    kometen_width,kometen_height]);                                         % nicht sichtbaren Bereich
set(handles.komet02, 'Position', [2,kometen_pos_y(2),...
    kometen_width,kometen_height]);
set(handles.komet03, 'Position', [2,kometen_pos_y(3),...
    kometen_width,kometen_height]);
set(handles.komet04, 'Position', [2,kometen_pos_y(4),...
    kometen_width,kometen_height]);
set(handles.komet05, 'Position', [2,kometen_pos_y(5),...
    kometen_width,kometen_height]);
set(handles.komet06, 'Position', [2,kometen_pos_y(6),...
    kometen_width,kometen_height]);
set(handles.komet07, 'Position', [2,kometen_pos_y(7),...
    kometen_width,kometen_height]);
set(handles.komet08, 'Position', [2,kometen_pos_y(8),...
    kometen_width,kometen_height]);
set(handles.komet09, 'Position', [2,kometen_pos_y(9),...
    kometen_width,kometen_height]);
set(handles.komet10, 'Position', [2,kometen_pos_y(10),...
    kometen_width,kometen_height]);





function kollision_pruefen(output1, output2, handles)
global delta_t kometen lektion;
spalte_planet = round(1+delta_t/2);                                         % Kometenspalte, die im Kollisionsbereich sind
for zaehler = 1:5                                                           % fr alle Kometen untereinander...
    if kometen(zaehler, spalte_planet) == 1                                 % wenn der Komet vorhanden ist...
        y_pos_planet = 3-zaehler;                                           % berechne y-Position des Kometen
        x_pos_planet = (spalte_planet-1)*2 - delta_t;                       % berechne x-Position des Kometen
        if sqrt((y_pos_planet-output1)^2+0.3 + x_pos_planet^2) < 0.8        % falls Spieler1 kollidiert...
            if sqrt((y_pos_planet-output2)^2+0.3 + x_pos_planet^2) < 0.8    % und auch Spieler2 kollidiert...
                objekte_auf_startzustand(handles);                          % beende das Spiel: unentschieden
                startbildschirm_zeichnen(lektion, handles);
                msgbox(['Beide Spieler hatten eine Kollision ',...
                    'mit einem Kometen!']);
                if (strcmp(computer,'PCWIN'))||(strcmp(computer,'PCWIN64')) % falls Windowsplatform genutzt wird...
                    sound_kollision = wavread('kollision_2');               % lade Sound fr zwei Kollisionen
                    wavplay(2*sound_kollision,2*8192);                      % spiele Sound ab
                end;
            else                                                            % ansonsten...
                objekte_auf_startzustand(handles);                          % beende das Spiel: Spieler1 hat verloren                                              
                startbildschirm_zeichnen(lektion, handles);
                msgbox('Spieler 1 hatte eine Kollision mit einem Kometen');
                if (strcmp(computer,'PCWIN'))||(strcmp(computer,'PCWIN64')) % falls Windowsplatform genutzt wird...
                    sound_kollision = wavread('kollision_1');               % lade Sound fr eine Kollision
                    wavplay(2*sound_kollision,2*8192);                      % spiele Sound ab
                end;
            end;
        end;
        if sqrt((y_pos_planet-output2)^2+0.3 + x_pos_planet^2) < 0.8        % wenn Spieler2 kollidiert...
            if sqrt((y_pos_planet-output1)^2+0.3 + x_pos_planet^2) >= 0.8   % wenn Spieler1 nicht kollidiert...
                objekte_auf_startzustand(handles);                          % beende das Spiel: Spieler2 hat verloren
                startbildschirm_zeichnen(lektion, handles);
                msgbox('Spieler 2 hatte eine Kollision mit einem Kometen');
                if (strcmp(computer,'PCWIN'))||(strcmp(computer,'PCWIN64')) % falls Windowsplatform genutzt wird...
                    sound_kollision = wavread('kollision_1');               % lade Sound fr eine Kollision
                    wavplay(2*sound_kollision,2*8192);                      % spiele Sound ab
                end;
            end;
        end;
    end;
end;




function objekte_auf_startzustand(handles)
global ttimer delta_t;
stop(ttimer);                                                               % stoppe Timer
delete(ttimer);                                                             % lsche Timer
set(handles.slider, 'Value', 0);                                            % Startposition des Sliders
set(handles.Startbutton, 'Enable', 'on');                                   % aktiviere Startbutton
set(handles.Pausebutton, 'Enable', 'off');                                  % deaktiviere Pausebutton
set(handles.Stopbutton, 'Enable', 'off');                                   % deaktiviere Stopbutton
delta_t = 0;                                                                % deaktiviere Graphikberlagerung
eingabefenster('on', handles);                                              % Eingabefenster aktivieren  
            
            


function eingabefenster(string, handles)                                    % Aktivierung bzw. Deaktivierung
global lektion;                                                             % der Eingabefenster, abhngig                                 
set(handles.kurvenmenu, 'Enable', string);                                  % von "string"
if lektion ~= 2                                                             
    set(handles.schwierigkeitsmenu, 'Enable', string); 
end;
set(handles.lektionsmenu, 'Enable', string);
set(handles.reglermenu1, 'Enable', string);
set(handles.reglermenu2, 'Enable', string);
set(handles.K_r1, 'Enable', string);
set(handles.K_r2, 'Enable', string);
set(handles.T_n1, 'Enable', string);
set(handles.T_n2, 'Enable', string);
set(handles.T_v1, 'Enable', string);
set(handles.T_v2, 'Enable', string);

set(handles.lektion2_manuell, 'Enable', string);
if (get(handles.lektion2_manuell, 'Value') == 0)
    set(handles.K_r_innen, 'Enable', string);
    set(handles.T_v_innen, 'Enable', string);
    set(handles.K_r_aussen, 'Enable', string);
    set(handles.T_n_aussen, 'Enable', string);
    set(handles.messrauschen, 'Enable', string);
    set(handles.radiobutton_umax, 'Enable', string);
    set(handles.radiobutton_awup, 'Enable', string);
    set(handles.slider_umax, 'Enable', string);
end;
set(handles.lastwechsel, 'Enable', string);

set(handles.lektion3_manuell, 'Enable', string);
if (get(handles.lektion3_manuell, 'Value') == 0)
    set(handles.lektion3_slider1, 'Enable', string);
    if (get(handles.lektion3_button_h_p,'Value')==1) 
        set(handles.lektion3_slider2, 'Enable', string);
    end;
    set(handles.lektion3_button_h, 'Enable', string);
    set(handles.lektion3_button_h_p, 'Enable', string);
end;



function reglerparameter_einlesen(handles)
global K_r1 T_n1 T_v1 K_r2 T_n2 T_v2 regler1 regler2 K1 K2;
s = tf('s');                                                                % deklariere s als Laplacevariable

K_r1 = str2num(get(handles.K_r1, 'String'));                                % Einlesen der Regelparameter Spieler1
T_n1 = str2num(get(handles.T_n1, 'String'));                                
T_v1 = str2num(get(handles.T_v1, 'String'));

K_r2 = str2num(get(handles.K_r2, 'String'));                                % Einlesen der Regelparameter Spieler2
T_n2 = str2num(get(handles.T_n2, 'String'));
T_v2 = str2num(get(handles.T_v2, 'String'));


switch get(handles.reglermenu1, 'Value')                                    % Auswahl des Reglertyps Spieler1
    case 1
        regler1 = 1;                                                        % Manuelle Regelung
        K1 = tf(1);
    case 2
        regler1 = 2;                                                        % P-Regler
        K1 = tf(K_r1);
    case 3
        regler1 = 3;                                                        % PI-Regler
        K1 = tf(K_r1 * (1 + 1/(T_n1*s)));
    case 4
        regler1 = 4;                                                        % PD-Regler
        K1 = tf(K_r1 * (1 + T_v1*s));
    case 5
        regler1 = 5;                                                        % PID-Regler
        K1 = tf(K_r1 * (1 + 1/(T_n1*s) + T_v1*s));
end;
switch get(handles.reglermenu2, 'Value')                                    % Auswahl des Reglertyps Spieler2
    case 1
        regler2 = 1;                                                        % Regler deaktiviert
        K2 = tf(0);
    case 2
        regler2 = 2;                                                        % P-Regler
        K2 = tf(K_r2);
    case 3
        regler2 = 3;                                                        % PI-Regler
        K2 = tf(K_r2 * (1 + 1/(T_n2*s)));
    case 4
        regler2 = 4;                                                        % PD-Regler
        K2 = tf(K_r2 * (1 + T_v2*s));
    case 5
        regler2 = 5;                                                        % PID-Regler
        K2 = tf(K_r2 * (1 + 1/(T_n2*s) + T_v2*s));
end;




function systemberechnung_lektion0(handles)                                 % Ausgangssystem
global K1 K2 G m G_z sys1 sys2 x0_1 x0_2;
s = tf('s');                                                                % deklariere s als Laplacevariable

K1.InputName = 'w1';                                                        % Namen der Eingnge
K2.InputName = 'w2';

G = tf(1 / (m*s^2));                                                        % Deklaration der Regelstrecke

G_z = tf(1 / (m*s^2));                                                      % Deklaration der Strgrenbertragung
G_z.InputName = 'z';                                                        % Name des Streingangs

sys1a = series(K1,G);                                                       % Reihenschaltung von K1 und G
sys2a = series(K2,G);                                                       % Reihenschaltung von K2 und G

sys1b = parallel(G_z,sys1a, [],[],1,1);                                     % Parallelschaltung von G_z und sys1
sys2b = parallel(G_z,sys2a, [],[],1,1);

sys1c = feedback(sys1b,1, 2,1);                                             % Feedback zum Eingang w
sys1c.OutputName = 'y1';
sys2c = feedback(sys2b,1, 2,1);
sys2c.OutputName = 'y2';

sys1 = ss(sys1c);                                                           % Konvertierung des Systems in den Zustandsraum
sys2 = ss(sys2c);

x0_1 = zeros(1,length(sys1.a));                                             % Festlegung der Anfangszustnde (Zeilenvektor)
x0_2 = zeros(1,length(sys2.a));




function systemberechnung_lektion1(handles)                                 % Strgrenaufschaltung
global K1 K2 G m G_z K_z1 K_z2 sys1 sys2 x0_1 x0_2;
s = tf('s');

K1.InputName = 'w1';                                                        % Namen der Eingnge
K2.InputName = 'w2';

G = tf(1 / (m*s^2));                                                        % Deklaration der Regelstrecke

G_z = tf((s+1) / (1/2*m^2*s^3 + m*s^2));                                    % Deklaration der Strgrenbertragung
G_z.InputName = 'z';                                                        % Name des Streingangs

sys1a = parallel(K_z1,K1, [],[],1,1);                                       % Parallelschaltung von K_z und K
sys2a = parallel(K_z2,K2, [],[],1,1);

sys1b = series(sys1a,G);                                                    % Reihenschaltung von sys1 und G
sys2b = series(sys2a,G);

sys1c = parallel(G_z,sys1b, 1,1,1,1);                                       % Parallelschaltung von G_z und sys1b
sys2c = parallel(G_z,sys2b, 1,1,1,1);                                       % Parallelschaltung von G_z und sys2b

sys1d = feedback(sys1c,1, 2,1);                                             % Feedback zum Eingang w
sys1d.OutputName = 'y1';
sys2d = feedback(sys2c,1, 2,1);
sys2d.OutputName = 'y2';

sys1 = ss(sys1d);                                                           % Konvertierung des Systems in den Zustandsraum
sys2 = ss(sys2d);

x0_1 = zeros(1,length(sys1.a));                                             % Festlegung der Anfangszustnde (Zeilenvektor)
x0_2 = zeros(1,length(sys2.a));




function systemberechnung_lektion2(handles)                                 % Kaskadenregelung
assignin('base', 'lektion2x0_0', 0);                                        % speichere Startzustnde in Workspace
assignin('base', 'lektion2x0_1', 0);
assignin('base', 'lektion2x0_2', 0);
assignin('base', 'lektion2x0_3', 0);
assignin('base', 'lektion2x0_4', 0);
assignin('base', 'K_r_innen', str2num(get(handles.K_r_innen, 'String')));   % speichere Reglerparameter in Workspace
assignin('base', 'T_v_innen', str2num(get(handles.T_v_innen, 'String')));
assignin('base', 'K_r_aussen', str2num(get(handles.K_r_aussen, 'String')));
assignin('base', 'T_n_aussen', str2num(get(handles.T_n_aussen, 'String')));

assignin('base', 'theta_offset', 0);                                        % speichere Lastwechsel = 0 in Workspace
if get(handles.messrauschen, 'Value')==1                                    % falls Merauschen aktiviert ist...
    assignin('base', 'noise_power', 0.3);                                   % speichere Merauschen mit Amplitude 0.3 in Workspace
else                                                                        % ansonsten...
    assignin('base', 'noise_power', 0);                                     % setze Amplitude des Merauschens auf 0
end;
assignin('base', 'noise_startvalue', abs(round(100000*rand)));              % Startwert fr Zufallsgenerator WhiteNoise

if (get(handles.radiobutton_umax, 'Value') == 1)
    assignin('base', 'u_limit', get(handles.slider_umax, 'Value')*pi/180);
    assignin('base', 'beschr', 1);
else
    assignin('base', 'u_limit', inf);
    assignin('base', 'beschr', 0);
end;
    
if (get(handles.radiobutton_awup, 'Value') == 1)
    assignin('base', 'awup', 1);
else
    assignin('base', 'awup', 0);
end;

if (get(handles.lektion2_manuell, 'Value') == 1)
    assignin('base', 'man', 1);
else
    assignin('base', 'man', 0);
end;
assignin('base', 'slider', 0);





function systemberechnung_lektion3(handles)
assignin('base', 'lektion3x0_0', 0);                                        % speichere Startzustnde in Workspace
assignin('base', 'lektion3x0_1', 0);
assignin('base', 'lektion3x0_2', 0);
assignin('base', 'lektion3x0_3', 400);                                      % Starthhe betrgt 400 m
lektion3_A = [-1/2 1 0 0; -6 -1/2 0 0; -200 0 0 200; 0 1 0 0];              % Systemmatrizzen A,B,C,D
lektion3_B = [0 -10 0 0]';
lektion3_C = [0 0 1 0; 0 0 0 1; -1 0 0 1];
lektion3_D = [0 0 0]';
lektion3_sys = ss(lektion3_A,lektion3_B,lektion3_C,lektion3_D);             % bilde State-Space des Systems
q1 = str2num(get(handles.text38,'String'));                                 % lese Gewichtung der Hhe h ein
q2 = get(handles.lektion3_slider2,'Value')*1e-8;                            % lese Gewichtung der Steiggeschwindigkeit h(p) ein
lektion3_Q = [q2*200^2 0 0 -q2*200^2;                                       % speichere Gewichtungen in Matrix
     0 0 0 0;
     0 0 q1 0;
     -q2*200^2 0 0 q2*200^2];
lektion3_R = 1;                                                             % Gewichtung des Eingangs = 1
[lektion3_K,dummy,dummy] = lqr(lektion3_sys,lektion3_Q,lektion3_R);         % berechne LQ-Regler anhand des Systems, Q und R
assignin('base', 'lektion3_K', lektion3_K);                                 % speichere erechnete Reglerparameter im Workspace

if (get(handles.lektion3_manuell, 'Value') == 1)
    assignin('base', 'man', 1);
else
    assignin('base', 'man', 0);
end;
assignin('base', 'slider', 0);



% --- Executes on button press in bode1.
function bode1_Callback(hObject, eventdata, handles)
global K1 G;
reglerparameter_einlesen(handles);                                          % berechne aktuellen Regler K1
figure();                                                                   % zeige neues Fenster an
margin(K1*G);                                                               % zeige Bodeplot mit Amplituden- und Phaseninfos an
legend('Fhrungsbertragungsfunktion Spieler1 (offen)');                    



% --- Executes on button press in bode2.
function bode2_Callback(hObject, eventdata, handles)
global K2 G;
reglerparameter_einlesen(handles);                                          % berechne aktuellen Regler K1
figure();                                                                   % zeige neues Fenster an
margin(K2*G);                                                               % zeige Bodeplot mit Amplituden- und Phaseninfos an
legend('Fhrungsbertragungsfunktion Spieler2 (offen)');



function startbildschirm_zeichnen(lektionsnr, handles)
global kurve_x kurve_y_start delta_t shuttle1 kometen ball1 ball2;
global landebahn_schwarz landebahn_gruen;
global eta_max;
cla(handles.axes1);
switch lektionsnr                                                           % unterscheide zwischen Lektionen...
    case {0,1}                                                              % falls Lektion 0 oder 1...
        plot(handles.axes1,kurve_x,kurve_y_start, 'Color','black');         % plotte ermittelte Sollkurve
        set(handles.axes1, 'XAxisLocation','bottom', 'YAxisLocation',...    % Eigenschaften des Plot-Fensters
            'right','XLim',[-2 20], 'YLim',[-2.5 2.5]);
        set(handles.spaceball1, 'Position',...                              % zeichne Spielfigur1 in Startposition
            [ball1.x0,ball1.y0,ball1.width,ball1.height]);
        set(handles.spaceball2, 'Position',...                              % zeichne Spielfigur2 in Startposition
            [ball2.x0,ball2.y0,ball2.width,ball2.height]);
        delta_t = 0;                                                        % setze Zeitfortschritt auf 0
        kometen_berechnen(kurve_y_start, handles);                          % berechne Kometenpositionen
        kometen_zeichnen(handles);                                          % zeichne Kometen
        set(handles.axes_shuttle1, 'Position',[2 shuttle1.y0...
            shuttle1.width shuttle1.height]);                               % verschiebe Shuttle-Plot in nicht sichtbaren Bereich
        set(handles.shuttle_lektion2,'Visible','off');                      % blende Shuttle-Lektion2-Eingabefenster aus
        set(handles.shuttle_lektion3,'Visible','off');                      % blende Shuttle-Lektion3-Eingabefenster aus
        set(handles.spieler1,'Visible','on');                               % blende Spieler1-Eingabefenster aus
        set(handles.spieler2,'Visible','on');                               % blende Spieler2-Eingabefenster aus
        set(handles.kurvenmenu, 'Enable', 'on');                            % aktiviere Kurvenmen
        set(handles.schwierigkeitsmenu, 'Enable', 'on');                    % aktiviere Schwierigkeitsmen
        if (lektionsnr == 0) set(handles.schwierigkeitsmenu, 'Value', 1);
        end;
        if (lektionsnr == 1) set(handles.schwierigkeitsmenu, 'Value', 2);
        end; 
        cla(handles.axes2);                                                 % lsche beide Sonnenwindanzeigen
        cla(handles.axes3);
        cla(handles.axes38);                                                % lsche Landebahnen
        cla(handles.axes39);
    case 2                                                                  % falls Lektion 2...  
        plot(handles.axes1,kurve_x,kurve_y_start, 'Color','black');         % plotte ermittelte Sollkurve
        set(handles.axes1, 'XAxisLocation','bottom', 'YAxisLocation',...    % Eigenschaften des Plot-Fensters
            'right','XLim',[-2 20], 'YLim',[-2.5 2.5]);
        kometen = zeros(5,20);                                              % setze alle Kometen auf 0 
        kometen_verbergen(handles);                                         % blende Kometen aus
        axes(handles.axes_shuttle1);                                        % lege aktuellen Plotter fest
        set(handles.spaceball1,'position',...                               % verschiebe Spaceball1 in nicht sichtb. Bereich
            [2,ball1.y0,ball1.width,ball1.height]);
        set(handles.spaceball2,'position',...                               % verschiebe Spaceball2 in nicht sichtb. Bereich
            [2,ball2.y0,ball2.width,ball2.height]);
        shuttle1_plot = image(shuttle1.p0);                                 % zeige gespeichertes Shuttle an
        set(shuttle1_plot,'AlphaData',shuttle1.p0trans);                    % mache das Bild transparent
        set(handles.axes_shuttle1, 'Visible', 'off');                       % blende Achsen aus
        set(handles.axes_shuttle1, 'Position',...                           % verschiebe Shuttle-Plot in sichtbaren Bereich 
            [shuttle1.x0 shuttle1.y0 shuttle1.width shuttle1.height]); 
        set(handles.shuttle_lektion2,'Visible','on');                       % blende Shuttle-Lektion2-Eingabefenster ein
        set(handles.shuttle_lektion3,'Visible','off');                      % blende Shuttle-Lektion3-Eingabefenster aus
        set(handles.axes_shuttle_ohne_lastw, 'Position',...
            [0.0258 0.3667 0.5822 0.481]);
        set(handles.axes_shuttle_mit_lastw, 'Position',...
            [2.0258 0.3667 0.5822 0.481]);
        set(handles.spieler1,'Visible','off');                              % blende Spieler1-Eingabefenster aus
        set(handles.spieler2,'Visible','off');                              % blende Spieler2-Eingabefenster aus
        set(handles.kurvenmenu, 'Enable', 'on');                            % aktiviere Kurvenmen
        set(handles.schwierigkeitsmenu, 'Value', 1);                        % setze Schwierigkeitsmen auf "ohne Sonnenwind"
        set(handles.schwierigkeitsmenu, 'Enable', 'off');                   % deaktiviere Schwierigkeitsmen
        cla(handles.axes38);                                                % blende Landebahnen aus
        cla(handles.axes39);
        
        if (get(handles.radiobutton_umax, 'Value') == 0)
            set(handles.uipanel_eta, 'Visible', 'off');
        else
            set(handles.uipanel_eta, 'Visible', 'on');
            axes(handles.axes_eta);
            cla;
            eta_max = pi/180*(get(handles.slider_umax, 'Value'));
            x = -2*cos(eta_max);
            y = 2*sin(eta_max);
            line([x 0],[y 0], 'LineWidth', 1, 'Color', 'red');
            line([x 0],[-y 0], 'LineWidth', 1, 'Color', 'red');
        end;
        line([-1 0],[0 0], 'LineWidth',2, 'Color', 'black');  
    case 3                                                                  % falls Lektion 3... 
        kometen = zeros(5,20);                                              % setze alle Kometen auf 0 
        kometen_verbergen(handles);                                         % verberge Kometen
        axes(handles.axes_shuttle1);                                        % lege aktuellen Plotter fest
        set(handles.spaceball1,'position',...                               % verschiebe Spaceball1 in nicht sichtb. Bereich
            [2,ball1.y0,ball1.width,ball1.height]);
        set(handles.spaceball2,'position',...                               % verschiebe Spaceball2 in nicht sichtb. Bereich
            [2,ball2.y0,ball2.width,ball2.height]);
        shuttle1_plot = image(shuttle1.p0);                                 % zeige gespeichertes Shuttle an
        set(shuttle1_plot,'AlphaData',shuttle1.p0trans);                    % mache das Bild transparent
        set(handles.axes_shuttle1, 'Visible', 'off');                       % blende Achsen aus
        set(handles.axes_shuttle1, 'Position',...                           % verschiebe Shuttle-Plot in sichtbaren Bereich 
            [shuttle1.x0 shuttle1.y0+0.152...
            shuttle1.width shuttle1.height]); 
        set(handles.axes1, 'XAxisLocation','bottom', 'YAxisLocation',...    % Eigenschaften des Plot-Fensters
            'right','XLim',[-400 4000], 'YLim',[-50 450]);
        set(handles.shuttle_lektion2,'Visible','off');                      % blende Shuttle-Lektion2-Eingabefenster aus
        set(handles.shuttle_lektion3,'Visible','on');                       % blende Shuttle-Lektion3-Eingabefenster ein  
        
        if get(handles.lektion3_button_h, 'Value') == 1
            lektion3_gewichtung1 = imread('lektion3_gewichtung_h.bmp');     % lese Bild der Gewichtungsmatrix ein
        end;
        if get(handles.lektion3_button_h_p, 'Value') == 1
            lektion3_gewichtung1 = imread('lektion3_gewichtung_h_p.bmp');   % lese Bild der Gewichtungsmatrix ein
        end;      
        axes(handles.axes_lektion3_gewichtung1);                            % whle Plotfenster aus
        image(lektion3_gewichtung1);                                        % zeige Gewichtungsmatrixbild an
        set(handles.axes_lektion3_gewichtung1, 'Visible', 'off');           % blende Achsenbeschriftungen aus
               
        lektion3_kosten = imread('lektion3_kostenfkt.bmp');                 % lese Bild der Kostenfkt und den Zustnden ein
       
        axes(handles.axes_lektion3_kostenfkt);                              % whle Plotfenster aus
        image(lektion3_kosten);                                             % zeige Bild an
        set(handles.axes_lektion3_kostenfkt, 'Visible', 'off');             % blende Achsenbeschriftungen aus
            
        set(handles.spieler1,'Visible','off');                              % blende Spieler1-Eingabefenster aus
        set(handles.spieler2,'Visible','off');                              % blende Spieler2-Eingabefenster aus
        set(handles.schwierigkeitsmenu, 'Value', 1);                        % setze Schwierigkeitsmen auf "ohne Sonnenwind"
        set(handles.schwierigkeitsmenu, 'Enable', 'off');                   % deaktiviere Schwierigkeitsmen
        set(handles.kurvenmenu, 'Enable', 'off');                           % deaktiviere Kurvenmen
        
        axes(handles.axes38);                                               % Whle Plotfenster der Landebahn aus                                           
        image(landebahn_schwarz);                                           % zeige Landebahn an
        set(handles.axes38, 'Visible', 'off');                              % blende Achsenbeschriftung aus
        
        pos_dummy = get(handles.axes39, 'Position');                        % lese Position der grnen Landebahn ein
        set(handles.axes39, 'Position', [0.883 pos_dummy(2)...              % verschiebe grne Landebahn in sichtbaren Bereich
            pos_dummy(3) pos_dummy(4)]);
        axes(handles.axes39);                                               % whle Plotfenster der Landebahn aus
        image(landebahn_gruen);                                             % zeige grne Landebahn an
        set(handles.axes39, 'Visible', 'off');                              % blende Achsenbeschriftung aus
end;





function reglermenu1_Callback(hObject, eventdata, handles)
auswahl = get(handles.reglermenu1, 'Value');                                % lese Auswahl Regler1 ein
switch auswahl                                                              % markiere fr getroffene Auswahl die
    case 1                                                                  % zugehrigen Regelparameter
        set(handles.K_r1, 'BackgroundColor', 'white');
        set(handles.T_n1, 'BackgroundColor', 'white');
        set(handles.T_v1, 'BackgroundColor', 'white');
    case 2
        set(handles.K_r1, 'BackgroundColor', 'green');
        set(handles.T_n1, 'BackgroundColor', 'white');
        set(handles.T_v1, 'BackgroundColor', 'white');
    case 3
        set(handles.K_r1, 'BackgroundColor', 'green');
        set(handles.T_n1, 'BackgroundColor', 'green');
        set(handles.T_v1, 'BackgroundColor', 'white');
    case 4
        set(handles.K_r1, 'BackgroundColor', 'green');
        set(handles.T_n1, 'BackgroundColor', 'white');
        set(handles.T_v1, 'BackgroundColor', 'green');
    case 5
        set(handles.K_r1, 'BackgroundColor', 'green');
        set(handles.T_n1, 'BackgroundColor', 'green');
        set(handles.T_v1, 'BackgroundColor', 'green');        
end;





function reglermenu2_Callback(hObject, eventdata, handles)
auswahl = get(handles.reglermenu2, 'Value');                                % lese Auswahl Regler2 ein
switch auswahl                                                              % markiere fr getroffene Auswahl die
    case 1                                                                  % zugehrigen Regelparameter
        set(handles.K_r2, 'BackgroundColor', 'white');
        set(handles.T_n2, 'BackgroundColor', 'white');
        set(handles.T_v2, 'BackgroundColor', 'white');
    case 2
        set(handles.K_r2, 'BackgroundColor', 'green');
        set(handles.T_n2, 'BackgroundColor', 'white');
        set(handles.T_v2, 'BackgroundColor', 'white');
    case 3
        set(handles.K_r2, 'BackgroundColor', 'green');
        set(handles.T_n2, 'BackgroundColor', 'green');
        set(handles.T_v2, 'BackgroundColor', 'white');
    case 4
        set(handles.K_r2, 'BackgroundColor', 'green');
        set(handles.T_n2, 'BackgroundColor', 'white');
        set(handles.T_v2, 'BackgroundColor', 'green');
    case 5
        set(handles.K_r2, 'BackgroundColor', 'green');
        set(handles.T_n2, 'BackgroundColor', 'green');
        set(handles.T_v2, 'BackgroundColor', 'green');        
end;




% --- Executes on selection change in kurvenmenu.
function kurvenmenu_Callback(hObject, eventdata, handles)
global kurve_x kurve_y_start lektion;
switch get(handles.kurvenmenu, 'Value')                                     % unterscheide zwischen Kurvenwahl...
    case 1                                                                  % falls Sinus...
        switch lektion                                                      % unterscheide zwischen Lektionen...
            case{0,1}                                                       % falls Lektion 0 oder1...
                kurve_y_start = sin(kurve_x);                               % lege Start-Sollkurve als Sinus fest
            case 2                                                          % falls Lektion 2...
                kurve_y_start = sin(kurve_x/2);                             % lege Start-Sollkurve als gedehnten Sinus fest
        end;
    case 2                                                                  % falls Zufallskurve...
        k1 = sin((0.5+rand)*kurve_x);                                       % berechne Sollverlauf durch
        k2 = 1/3*sin((0.5+3*rand)*kurve_x);                                 % berlagerung zuflliger Sinus-Moden
        k3 = 1/6*sin((0.5+6*rand)*kurve_x);                                
        k4 = 1/9*sin((0.5+9*rand)*kurve_x);
        k5 = 1/11*sin((0.5+11*rand)*kurve_x);
        kurve_y_start = k1 + k2 + k3 + k4 + k5;
        kurve_y_start = kurve_y_start/max(abs(kurve_y_start));
    case 3                                                                  % falls Sprungfkt...
        kurve_y_start = [zeros(1,30) ones(1,391)];                          % berechne Sprungfkt mit Sprung bei t=1s
end;
startbildschirm_zeichnen(lektion, handles);                                 % zeichne Startbildschirm der aktuellen Lektion neu





% --- Executes on selection change in lektionsmenu.
function lektionsmenu_Callback(hObject, eventdata, handles)
global lektion K_z1 K_z2 kurve_x kurve_y_start;
switch get(handles.lektionsmenu, 'Value')                                   % unterscheide zwischen Lektionswahl...
    case 1                                                                  % falls Lektion 0... 
        truesize(Lektion0);                                                 % ffne Lektion0 in Originalgre
        uiwait(Lektion0);                                                   % warte auf Rckmeldung
        close(Lektion0);                                                    % schliee Lektion0
        lektion = 0;                                                        % setze Lektionsspeicher auf 0
        assignin('base', 'lektion1_auswahl', 0);                            % speichere im WS, dass keine andere,ausser Lektion1 ausgewhlt wurde
        assignin('base', 'lektion2_auswahl', 0);
        assignin('base', 'lektion3_auswahl', 0);
        set(handles.kurvenmenu, 'Value', 1);                                % setze Kurvenmen auf Sinus
        kurve_y_start = sin(kurve_x);                                       % berechne Startkurve als Sinus
        startbildschirm_zeichnen(0, handles)                                % zeichne Startbildschirm fr Lektion 0 neu
    case 2                                                                  % falls Lektion 1...
        truesize(Lektion1);                                                 % ffne Lektion1 in Originalgre
        uiwait(Lektion1);                                                   % warte auf Rckmeldung
        close(Lektion1);                                                    % schliee Lektion1
        lektion1_auswahl = evalin('base', 'lektion1_auswahl');       
        if lektion1_auswahl == 1                                            % wenn Rckgabe "Weiter"...
            lektion = 1;                                                    % setze Lektionsspeicher auf 1
            assignin('base', 'lektion2_auswahl', 0);                        % speichere im WS, dass keine andere,ausser Lektion2 ausgewhlt wurde
            assignin('base', 'lektion3_auswahl', 0);
            K_z1 = evalin('base', 'lektion1_K_z1');                         % lese die im WS gespeicherten Strentkopplungs--Fktn ein
            K_z2 = evalin('base', 'lektion1_K_z2');
            set(handles.kurvenmenu, 'Value', 1);                            % setze Kurvenmen auf Sinus
            kurve_y_start = sin(kurve_x);                                   % berechne Startkurve als Sinus
            startbildschirm_zeichnen(1, handles);                           % zeichne Startbildschirm fr Lektion 1 neu
        else                                                                % ansonsten...
            set(handles.lektionsmenu, 'Value', 1);                          % setze Lektionsmen auf Lektion 0
            lektion = 0;                                                    % setze Lektionsspeicher auf 0 
            assignin('base', 'lektion1_auswahl', 0);                        % speichere im WS, dass keine andere,ausser Lektion0 ausgewhlt wurde
            assignin('base', 'lektion2_auswahl', 0);
            assignin('base', 'lektion3_auswahl', 0);
            set(handles.kurvenmenu, 'Value', 1);                            % setze das Kurvenmen auf Sinus
            kurve_y_start = sin(kurve_x);                                   % berechne Sollkurve neu
            startbildschirm_zeichnen(0, handles);                           % zeige Startbildschirm fr Lektion0 an
        end;
    case 3                                                                  % falls Lektion 2...
        truesize(Lektion2);                                                 % ffne Lektion1 in Originalgre        
        uiwait(Lektion2);                                                   % warte auf Rckmeldung
        lektion2_auswahl = evalin('base', 'lektion2_auswahl');              % lese Merker ein
        if lektion2_auswahl == 1                                            % wenn ok eingegeben wurde...
            lektion = 2;                                                    % setze Lektionsspeicher auf 2
            assignin('base', 'lektion1_auswahl', 0);                        % speichere im WS, dass keine andere,ausser Lektion2 ausgewhlt wurde
            assignin('base', 'lektion3_auswahl', 0);
            set(handles.kurvenmenu, 'Value', 3);                            % setze Kurvenmen auf Sprung
            kurve_y_start = [zeros(1,30) ones(1,391)];                      % berechne Startkurve als Sprung
            startbildschirm_zeichnen(2, handles);                           % zeichne Startbildschirm fr Lektion 2 neu          
            lektion2_K_r_innen = evalin('base', 'lektion2_K_r_innen');      % lese eingegebene Reglerparameter der Kaskadenregelung ein
            lektion2_T_v_innen = evalin('base', 'lektion2_T_v_innen');
            lektion2_K_r_aussen = evalin('base', 'lektion2_K_r_aussen');            
            set(handles.K_r_innen, 'String',...                             % zeige bergebene Reglerparameter an
                num2str(lektion2_K_r_innen));
            set(handles.T_v_innen, 'String',...
                num2str(lektion2_T_v_innen));
            set(handles.K_r_aussen, 'String',...
                num2str(lektion2_K_r_aussen));
        else                                                                % ansonsten...
            close(Lektion2);                                                % schliee Lektion2
            set(handles.lektionsmenu, 'Value', 1);                          % setze Lektionsmen auf Lektion 0
            lektion = 0;                                                    % setze Lektionsspeicher auf 0
            assignin('base', 'lektion1_auswahl', 0);                        % speichere im WS, dass keine andere,ausser Lektion0 ausgewhlt wurde
            assignin('base', 'lektion2_auswahl', 0);
            assignin('base', 'lektion3_auswahl', 0);
            set(handles.kurvenmenu, 'Value', 1);                            % setze Kurvenmen auf Sinus
            kurve_y_start = sin(kurve_x);                                   % berechne Startkurve als Sinus
            startbildschirm_zeichnen(0, handles);                           % zeichne Startbildschirm fr Lektion 0 neu
        end; 
    case 4                                                                  % falls Lektion3...    
        truesize(Lektion3);                                                 % zeige Lektion3 in Originalgre an
        uiwait(Lektion3);                                                   % warte auf Rckmeldung
        lektion3_auswahl = evalin('base', 'lektion3_auswahl');              % lese Merker ein
        if lektion3_auswahl == 1                                            % wenn ok eingegeben wurde...
            lektion = 3;                                                    % setze Lektionsspeicher auf 3
            assignin('base', 'lektion1_auswahl', 0);                        % speichere im WS, dass keine andere,ausser Lektion3 ausgewhlt wurde
            assignin('base', 'lektion2_auswahl', 0);
            set(handles.kurvenmenu, 'Value', 3);                            % setze Kurvenmen auf Sprung
            kurve_y_start = -0.15*ones(1,421);                              % berechne Startkurve als Nulllinie
            startbildschirm_zeichnen(3, handles);                           % zeichne Startbildschirm fr Lektion 3 neu
        else                                                                % ansonsten...
            close(Lektion3);                                                % schliee Lektion3
            set(handles.lektionsmenu, 'Value', 1);                          % setze Lektionsmen auf Lektion 0
            lektion = 0;                                                    % setze Lektionsspeicher auf 0
            assignin('base', 'lektion1_auswahl', 0);                        % speichere im WS, dass keine andere,ausser Lektion0 ausgewhlt wurde
            assignin('base', 'lektion2_auswahl', 0);
            assignin('base', 'lektion3_auswahl', 0);
            set(handles.kurvenmenu, 'Value', 1);                            % setze Kurvenmen auf Sinus
            kurve_y_start = sin(kurve_x);                                   % berechne Startkurve als Sinus
            startbildschirm_zeichnen(0, handles);                           % zeichne Startbildschirm fr Lektion 0 neu
        end; 
end;




% --- Executes on slider movement.
function lektion3_slider1_Callback(hObject, eventdata, handles)
set(handles.text38,'String',...                                             % zeige Gewichtung der Hhe (Lektion3) an
    [num2str(round(get(handles.lektion3_slider1,'Value'))),'e-9']);




% --- Executes on slider movement.
function lektion3_slider2_Callback(hObject, eventdata, handles)
set(handles.text_gewichtung_h_p1,'String',[num2str(...                      % zeige Gewichtung der Steiggeschwindigkeit (Lektion3) an
    round(get(handles.lektion3_slider2,'Value')/5)*5),'e-8*v0^2']);
set(handles.text_gewichtung_h_p2,'String',[num2str(...
    round(get(handles.lektion3_slider2,'Value')/5)*5),'e-8*v0^2']);
set(handles.text_gewichtung_h_p3,'String',[num2str(...
    round(get(handles.lektion3_slider2,'Value')/5)*5),'e-8*v0^2']);
set(handles.text_gewichtung_h_p4,'String',[num2str(...
    round(get(handles.lektion3_slider2,'Value')/5)*5),'e-8*v0^2']);




% --- Executes on button press in lektion3_button_h.
function lektion3_button_h_Callback(hObject, eventdata, handles)
if (get(handles.lektion3_button_h,'value')==0) && ...                       % falls Gewichtung h und h(p) nicht aktiviert sind...
        (get(handles.lektion3_button_h_p,'value')==0)
    set(handles.lektion3_button_h,'value',1);                               % aktiviere Gewichtung h
else                                                                        % ansonsten...
    lektion3_gewichtung1 = imread('lektion3_gewichtung_h.bmp');             % lese Bild der Gewichtungsmatrix ein
    axes(handles.axes_lektion3_gewichtung1);                                % whle Plotfenster aus
    image(lektion3_gewichtung1);                                            % zeige Gewichtungsmatrixbild an
    set(handles.axes_lektion3_gewichtung1, 'Visible', 'off');               % blende Achsenbeschriftungen aus    
    
    set(handles.text_gewichtung_h_p1, 'Visible', 'off');                    % blende nicht benutzte Gewichtungsanzeigen aus
    set(handles.text_gewichtung_h_p2, 'Visible', 'off');
    set(handles.text_gewichtung_h_p3, 'Visible', 'off');
    set(handles.text_gewichtung_h_p4, 'Visible', 'off');
 
    set(handles.lektion3_slider2,'Value',0,'Enable','off');                 % deaktiviere Slider fr Gewichtung h(p) und setze Slider auf 0
    lektion3_slider2_Callback(hObject, eventdata, handles);                 % rufe Slider-Callback fr Gewichtung h(p) auf
end;




% --- Executes on button press in lektion3_button_h_p.
function lektion3_button_h_p_Callback(hObject, eventdata, handles)
if (get(handles.lektion3_button_h,'value')==0) && ...                       % falls Gewichtung h und h(p) nicht aktiviert sind...
        (get(handles.lektion3_button_h_p,'value')==0)
    set(handles.lektion3_button_h_p,'value',1);                             % aktiviere Gewichtung h(p)
else                                                                        % ansonsten...
    lektion3_gewichtung1 = imread('lektion3_gewichtung_h_p.bmp');           % lese Bild der Gewichtungsmatrix ein
    axes(handles.axes_lektion3_gewichtung1);                                % whle Plotfenster aus
    image(lektion3_gewichtung1);                                            % zeige Gewichtungsmatrixbild an
    set(handles.axes_lektion3_gewichtung1, 'Visible', 'off');               % blende Achsenbeschriftungen aus
    
    set(handles.text_gewichtung_h_p1, 'Visible', 'on');                     % blende zustzliche Gewichtungsanzeigen ein
    set(handles.text_gewichtung_h_p2, 'Visible', 'on');
    set(handles.text_gewichtung_h_p3, 'Visible', 'on');
    set(handles.text_gewichtung_h_p4, 'Visible', 'on');
     
    truesize(Lektion3_test2);                                               % ffne Test2 der Lektion3 in Originalgre
    uiwait(Lektion3_test2);                                                 % warte auf Rckmeldung
    close(Lektion3_test2);                                                  % schliee Test2 der Lektion3
    
    set(handles.lektion3_slider2,'Enable','on');                            % aktiviere Slider fr Gewichtung h(p)
end;




% --- Executes on button press in Bildschirm.
function Bildschirm_Callback(hObject, eventdata, handles)
ist = imread('ist.bmp');                                                    % lade ist-Logo
axes(handles.axes10);                                                       % setze axes-Handle auf axes10
image(ist);                                                                 % zeige ist-Logo
set(handles.axes10, 'Visible', 'off');                                      % blende Achsenbeschriftung aus

truesize();                                                                 % blende Spaceball-Fenster in Originalgre ein




% --- Executes on slider movement.
function slider_umax_Callback(hObject, eventdata, handles)
global eta_max;
umax_wert = num2str(round(get(handles.slider_umax, 'Value')));
set(handles.text_umax, 'String',...
    ['-',umax_wert,' <= eta <= +',umax_wert,'']);

axes(handles.axes_eta);
cla;
eta_max = pi/180*(get(handles.slider_umax, 'Value'));
x = -2*cos(eta_max);
y = 2*sin(eta_max);
line([x 0],[y 0], 'LineWidth', 1, 'Color', 'red');
line([x 0],[-y 0], 'LineWidth', 1, 'Color', 'red');
line([-1 0],[0 0], 'LineWidth',2, 'Color', 'black');




% --- Executes on button press in radiobutton_umax.
function radiobutton_umax_Callback(hObject, eventdata, handles)
global eta_max;
if (get(handles.radiobutton_umax, 'Value') == 1)
    truesize(Lektion2_test3);                                               % ffne Test3 der Lektion2 in Originalgre
    uiwait(Lektion2_test3);                                                 % warte auf Rckmeldung
    close(Lektion2_test3);                                                  % schliee Test3 der Lektion2
    
    set(handles.K_r_innen, 'String', '-1');
    set(handles.T_v_innen, 'String', '0.1');
    set(handles.K_r_aussen, 'String', '0.004');
    set(handles.T_n_aussen, 'String', '20');    

    set(handles.text_T_n_aussen, 'Visible', 'on');
    set(handles.T_n_aussen, 'Visible', 'on');
    set(handles.text_umax, 'Visible', 'on');
    set(handles.slider_umax, 'Visible', 'on');
    set(handles.radiobutton_awup, 'Visible', 'on');
    
    set(handles.slider_umax, 'Value', 65);
    slider_umax_Callback(hObject, eventdata, handles);
    set(handles.uipanel_eta, 'Visible', 'on');
    axes(handles.axes_eta);
    cla;
    eta_max = pi/180*65;
    x = -2*cos(eta_max);
    y = 2*sin(eta_max);
    line([x 0],[y 0], 'LineWidth', 1, 'Color', 'red');
    line([x 0],[-y 0], 'LineWidth', 1, 'Color', 'red');
    line([-1 0],[0 0], 'LineWidth',2, 'Color', 'black');
else
    set(handles.K_r_innen, 'String', '0');
    set(handles.T_v_innen, 'String', '0');
    set(handles.K_r_aussen, 'String', '0');
    set(handles.T_n_aussen, 'String', '1');
    
    set(handles.text_T_n_aussen, 'Visible', 'off');
    set(handles.T_n_aussen, 'Visible', 'off');
    set(handles.text_umax, 'Visible', 'off');
    set(handles.slider_umax, 'Visible', 'off');
    set(handles.radiobutton_awup, 'Visible', 'off');
    set(handles.radiobutton_awup, 'Value', 0);
    slider_umax_Callback(hObject, eventdata, handles);
    
    set(handles.uipanel_eta, 'Visible', 'off');
    eta_max = inf;
end;




% --- Executes on button press in lektion2_manuell.
function lektion2_manuell_Callback(hObject, eventdata, handles)
if (get(handles.lektion2_manuell, 'Value') == 1)
    set(handles.K_r_innen, 'Enable', 'off');
    set(handles.T_v_innen, 'Enable', 'off');
    set(handles.K_r_aussen, 'Enable', 'off');
    set(handles.T_n_aussen, 'Enable', 'off');
    set(handles.messrauschen, 'Enable', 'off');
    set(handles.radiobutton_umax, 'Value', 0);
    radiobutton_umax_Callback(hObject, eventdata, handles);
    set(handles.radiobutton_umax, 'Enable', 'off');
    set(handles.radiobutton_awup, 'Enable', 'off');
    set(handles.slider_umax, 'Enable', 'off');   
else
    set(handles.K_r_innen, 'Enable', 'on');
    set(handles.T_v_innen, 'Enable', 'on');
    set(handles.K_r_aussen, 'Enable', 'on');
    set(handles.T_n_aussen, 'Enable', 'on');
    set(handles.messrauschen, 'Enable', 'on');
    set(handles.radiobutton_umax, 'Enable', 'on');
    set(handles.radiobutton_awup, 'Enable', 'on');
    set(handles.slider_umax, 'Enable', 'on');
end;



% --- Executes on button press in lektion3_manuell.
function lektion3_manuell_Callback(hObject, eventdata, handles)
if (get(handles.lektion3_manuell, 'Value') == 1)
    set(handles.lektion3_button_h, 'Enable', 'off');
    set(handles.lektion3_button_h_p, 'Enable', 'off');
    set(handles.lektion3_slider1, 'Enable', 'off');
    set(handles.lektion3_slider2, 'Enable', 'off');
else
    set(handles.lektion3_button_h, 'Enable', 'on');
    set(handles.lektion3_button_h_p, 'Enable', 'on');
    set(handles.lektion3_slider1, 'Enable', 'on');
    set(handles.lektion3_slider2, 'Enable', 'on');
end;


%**************************************************************************
%**************************************************************************
% Nicht verwendete Callback-Funktions-Rmpfe folgen



function reglermenu1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function popupmenu3_Callback(hObject, eventdata, handles)



function popupmenu3_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function K_r1_Callback(hObject, eventdata, handles)


function K_r1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function T_n1_Callback(hObject, eventdata, handles)


function T_n1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function T_v1_Callback(hObject, eventdata, handles)


function T_v1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit4_Callback(hObject, eventdata, handles)


function edit4_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit5_Callback(hObject, eventdata, handles)


function edit5_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)


function edit6_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function K_r2_Callback(hObject, eventdata, handles)


function K_r2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function T_n2_Callback(hObject, eventdata, handles)


function T_n2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function T_v2_Callback(hObject, eventdata, handles)


function T_v2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function varargout = spacecraft_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function slider_Callback(hObject, eventdata, handles)



function slider_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function reglermenu2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function anti_dist1num_Callback(hObject, eventdata, handles)


function anti_dist1num_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function anti_disturbance2_Callback(hObject, eventdata, handles)


function anti_disturbance2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit10_Callback(hObject, eventdata, handles)


function edit10_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function kurvenmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to kurvenmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called




% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on selection change in schwierigkeitsmenu.
function schwierigkeitsmenu_Callback(hObject, eventdata, handles)
% hObject    handle to schwierigkeitsmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns schwierigkeitsmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from schwierigkeitsmenu


% --- Executes during object creation, after setting all properties.
function schwierigkeitsmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to schwierigkeitsmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in lektion0.
function lektion0_Callback(hObject, eventdata, handles)
% hObject    handle to lektion0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in lektion1.
function lektion1_Callback(hObject, eventdata, handles)
% hObject    handle to lektion1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in popupmenu6.
function popupmenu6_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu6 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu6


% --- Executes during object creation, after setting all properties.
function popupmenu6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit14_Callback(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit14 as text
%        str2double(get(hObject,'String')) returns contents of edit14 as a double


% --- Executes during object creation, after setting all properties.
function edit14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function edit15_Callback(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit15 as text
%        str2double(get(hObject,'String')) returns contents of edit15 as a double


% --- Executes during object creation, after setting all properties.
function edit15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function K_r_aussen_Callback(hObject, eventdata, handles)
% hObject    handle to K_r_aussen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of K_r_aussen as text
%        str2double(get(hObject,'String')) returns contents of K_r_aussen as a double


% --- Executes during object creation, after setting all properties.
function K_r_aussen_CreateFcn(hObject, eventdata, handles)
% hObject    handle to K_r_aussen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function K_r_innen_Callback(hObject, eventdata, handles)
% hObject    handle to K_r_innen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of K_r_innen as text
%        str2double(get(hObject,'String')) returns contents of K_r_innen as a double


% --- Executes during object creation, after setting all properties.
function K_r_innen_CreateFcn(hObject, eventdata, handles)
% hObject    handle to K_r_innen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function T_v_innen_Callback(hObject, eventdata, handles)
% hObject    handle to T_v_innen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T_v_innen as text
%        str2double(get(hObject,'String')) returns contents of T_v_innen as a double


% --- Executes during object creation, after setting all properties.
function T_v_innen_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T_v_innen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in messrauschen.
function messrauschen_Callback(hObject, eventdata, handles)
% hObject    handle to messrauschen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of messrauschen


% --- Executes on button press in lastwechsel.
function lastwechsel_Callback(hObject, eventdata, handles)
% hObject    handle to lastwechsel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of lastwechsel




% --- Executes during object creation, after setting all properties.
function bildschirm_CreateFcn(hObject, eventdata, handles)
% hObject    handle to bildschirm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end








function edit23_Callback(hObject, eventdata, handles)
% hObject    handle to edit23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit23 as text
%        str2double(get(hObject,'String')) returns contents of edit23 as a double


% --- Executes during object creation, after setting all properties.
function edit23_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider3_Callback(hObject, eventdata, handles)
% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end




% --- Executes during object creation, after setting all properties.
function lektion3_slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lektion3_slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end




% --- Executes during object creation, after setting all properties.
function lektion3_slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lektion3_slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



% --- Executes on key press with focus on Bildschirm and no controls selected.
function Bildschirm_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to Bildschirm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function lektionsmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lektionsmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider6_Callback(hObject, eventdata, handles)
% hObject    handle to slider6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end




% --- Executes during object creation, after setting all properties.
function slider_umax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_umax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end




% --- Executes on button press in radiobutton_awup.
function radiobutton_awup_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_awup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_awup





function T_n_aussen_Callback(hObject, eventdata, handles)
% hObject    handle to T_n_aussen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T_n_aussen as text
%        str2double(get(hObject,'String')) returns contents of T_n_aussen as a double


% --- Executes during object creation, after setting all properties.
function T_n_aussen_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T_n_aussen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
